<?php

namespace App\Http\Controllers\API;

use App\Http\Controllers\API\BaseController as BaseController;
use Illuminate\Http\Request;
use App\Models\Product;
use App\Models\ScannedProduct;
use Redirect;
use Auth;
use Log;
use URL;

class MobileappController extends BaseController
{
    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct()
    {
        // $this->middleware('auth');
    }

    /**
     * Show the application dashboard.
     *
     * @return \Illuminate\Contracts\Support\Renderable
     */
    public function index()
    {
        return view('home');
    }

    public function user()
    {
        return response()->json([
            'status'        => true,
            'data'          => Auth::user(),
            'token_type'    => 'Bearer',
        ]);
    }

    public function scanProduct(Request $request){
        $scanned_qr_code                                        = $request->input('product_code');
        $code_decoded                                           = explode('-', $scanned_qr_code);
        $success                                                = [];
        if(sizeof($code_decoded) > 5){          
            $product_id                                         = $code_decoded[2];
            $product_dtls                                       = Product::where(['id' =>$product_id,'status' => 1])
                                                                    ->first();
            if($product_dtls){
                $scanned_product_dtls                           = ScannedProduct::where([
                                                                        'user_id'       => Auth::user()->id,
                                                                        'product_id'    => $product_dtls->id,
                                                                        'company_id'    => $product_dtls->company_id,
                                                                        'code'          => $scanned_qr_code
                                                                    ])->first();
                if($scanned_product_dtls){
                    $scanned_product_dtls->scan_count++;
                    $success['scan_count']                      = $scanned_product_dtls->scan_count;
                }else{
                    $product_authorization                      = ScannedProduct::where('code',$scanned_qr_code)->first();
                    $scanned_product_dtls                       = new ScannedProduct();
                    $scanned_product_dtls->user_id              = Auth::user()->id;
                    $scanned_product_dtls->product_id           = $product_dtls->id;
                    $scanned_product_dtls->company_id           = $product_dtls->company_id;
                    $scanned_product_dtls->scan_count           = 1;
                    $scanned_product_dtls->code                 = $scanned_qr_code;

                    $scanned_product_dtls->latitude             = $request->input('latitude');
                    $scanned_product_dtls->longitude            = $request->input('longitude');

                    if($product_authorization){
                        $scanned_product_dtls->authorization    = 0;
                        $success['scan_message']                = 'Duplicate Product!';
                        $success['scan_count']                  = $scanned_product_dtls->scan_count;
                    }else{
                        $scanned_product_dtls->authorization    = 1;
                        $success['scan_message']                = 'Genuine Product!';
                    }
                }
                $scanned_product_dtls->save();
                $success['product_code']                        = $product_dtls->product_code;
                $success['scan_count']                          = $scanned_product_dtls->scan_count;
                $success['product_brand_name']                  = $product_dtls->brand_name;
                $success['scanned_code']                        = $scanned_product_dtls->code;

                if($product_dtls->auth_prod_name != ''){
                    $success['product_name']                    = $product_dtls->auth_prod_name;
                }else{
                    $success['product_name']                    = $product_dtls->product_name;
                }

                if($product_dtls->auth_done_by != ''){
                    $success['company_name']                    = $product_dtls->auth_done_by;
                }else{
                    $success['company_name']                    = $product_dtls->company->company_name;
                }

                $success['category']                            = $product_dtls->category->category;
                $success['auth_status']                         = $scanned_product_dtls->authorization;
                $success['product_image']                       = 'storage/app/images/'.$product_dtls->product_image;


                if($scanned_product_dtls->authorization == 1){
                        $success['product_warranty_status']   = 0;
                        $success['product_replace_warranty_status']   = false;
                        if($scanned_product_dtls->product->productWarranty){
                            if($scanned_product_dtls->product->productWarranty->waranty_status == 'Yes' && $scanned_product_dtls->product->productWarranty->warranty_type == 1){
                                $success['product_warranty_status']           = 1;
                                $success['warranty_details']                  = [];
                                if($scanned_product_dtls->product->productWarranty->full_product == 'Yes'){
                                    $success['warranty_details']['product_warranty']  =  true;
                                    $success['warranty_details']['waranty_period']    = $scanned_product_dtls->product->productWarranty->s_warranty_count;
                                }

                                if($scanned_product_dtls->product->productWarranty->full_product == 'No'){
                                    $success['warranty_details']['product_warranty']  = false;

                                    if(sizeof($scanned_product_dtls->product->partWarranty) > 0){
                                        $part_names                             = [];
                                        $part_duration                          = [];
                                        foreach ($scanned_product_dtls->product->partWarranty as $parts) {
                                            $part_names[]                       = $parts->part_name;
                                            $part_duration[]                    = $parts->part_warranty_count;
                                        }
                                        $success['warranty_details']['part_name']                 = $part_names;
                                        $success['warranty_details']['part_duration']             = $part_duration;
                                    }
                                
                                }
                            }

                            if($scanned_product_dtls->product->productWarranty->warranty_type == 2){ 
                                if($scanned_product_dtls->product->productWarranty->r_warranty_count > 0) {
                                    $success['product_replace_warranty_status']   = true;
                                    $success['product_warranty_status']           = 1;
                                    $success['warranty_details']['waranty_period']   = $scanned_product_dtls->product->productWarranty->r_warranty_count;
                                }
                            }
                        }
                    }else{
                        $success['product_warranty_status']   = 0;
                    }
                return $this->sendResponse($success, 'Scanning Successfull.');
            }else{
                return $this->sendError('Unauthorized Product. Please recheck!'); 
            }
        }else{
            return $this->sendError('Unauthorized Product. Please recheck!'); 
        }
        return $this->sendResponse($success, 'Scanning Successfull.');
    }

    public function scannedProductDetails(){
        $scanned_product_list                           = ScannedProduct::where('user_id' , Auth::user()->id)->orderBy('updated_at','desc')->get();
        if($scanned_product_list->isEmpty()){
            return $this->sendError('No Data Found'); 
        }else{
            $success                                    = ['status' => true];
            if($scanned_product_list->isNotEmpty()){
                foreach($scanned_product_list as $scanned_product) {
                    $temp_data                          = [];
                    $temp_data                          = [
                                                                'scan_id'           => $scanned_product->id,
                                                                'product_name'      => $scanned_product->product->product_name,
                                                                'product_description'=> $scanned_product->product->product_name,
                                                                'product_brand_name'=> $scanned_product->product->brand_name,
                                                                'scanned_time'      => date('d-m-Y', strtotime($scanned_product->updated_at)),
                                                                'product_image'     => 'storage/app/images/'.$scanned_product->product->product_image,
                                                                'auth_status'       => $scanned_product->authorization,
                                                                'scanned_code'      => $scanned_product->code,
                                                                'scan_count'        => $scanned_product->scan_count
                                                            ];

                    if($scanned_product->product->auth_prod_name != ''){
                        $temp_data['product_name']      = $scanned_product->product->auth_prod_name;
                    }else{
                        $temp_data['product_name']      = $scanned_product->product->product_name;
                    }

                    if($scanned_product->product->auth_done_by != ''){
                        $temp_data['company_name']      = $scanned_product->product->auth_done_by;
                    }else{
                        $temp_data['company_name']      = $scanned_product->product->company->company_name;
                    }

                    if($scanned_product->chat){
                        $temp_data['chat_status']       = 1;
                    }else{
                        $temp_data['chat_status']       = 0;
                    }
                    if($scanned_product->warranty){
                        $temp_data['warranty_status']   = 1;
                    }else{
                        $temp_data['warranty_status']   = 0;
                    }

                    if($scanned_product->authorization == 1){
                        $temp_data['product_warranty_status']   = 0;
                        $temp_data['product_replace_warranty_status']   = false;
                        if($scanned_product->product->productWarranty){
                            if($scanned_product->product->productWarranty->waranty_status == 'Yes' && $scanned_product->product->productWarranty->warranty_type == 1){
                                $temp_data['product_warranty_status']           = 1;
                                $temp_data['warranty_details']                  = [];
                                if($scanned_product->product->productWarranty->full_product == 'Yes'){
                                    $temp_data['warranty_details']['product_warranty']  =  true;
                                    $temp_data['warranty_details']['waranty_period']    = (int)$scanned_product->product->productWarranty->s_warranty_count;
                                }

                                if($scanned_product->product->productWarranty->full_product == 'No'){
                                    $temp_data['warranty_details']['product_warranty']  = false;

                                    if(sizeof($scanned_product->product->partWarranty) > 0){
                                        $part_names                             = [];
                                        $part_duration                          = [];
                                        foreach ($scanned_product->product->partWarranty as $parts) {
                                            $part_names[]                       = $parts->part_name;
                                            $part_duration[]                    = $parts->part_warranty_count;
                                        }
                                        $temp_data['warranty_details']['part_name']                 = $part_names;
                                        $temp_data['warranty_details']['part_duration']             = $part_duration;
                                    }
                                
                                }
                            }

                            if($scanned_product->product->productWarranty->warranty_type == 2){ 
                                if($scanned_product->product->productWarranty->r_warranty_count > 0) {
                                    $temp_data['product_replace_warranty_status']   = true;
                                    $temp_data['product_warranty_status']           = 1;
                                    $temp_data['warranty_details']['waranty_period']   = $scanned_product->product->productWarranty->r_warranty_count;
                                }
                            }
                        }
                    }else{
                        $temp_data['product_warranty_status']   = 0;
                    }

                    $success['product_list'][]          =  $temp_data;  
                }
            }else{
                return $this->sendError('No Data Found');
            }
            echo json_encode($success);
            return ;
        }
    }
    
    public function details($product_code){
        return Redirect::away('https://www.google.com/');
    }

    public function removeScannedProduct(Request $request){
        $scanned_product        = ScannedProduct::where(['user_id' => Auth::user()->id])->find($request->input('scan_id'));
        if($scanned_product){
                                  $scanned_product->delete();            
            $success            = [
                                    'status'    => true,
                                    'message'   => 'Removed from list'
                                ];            
            echo json_encode($success);
            return ;
        }else{
            return $this->sendError('No Data Found');
        }
    }

}














