<?php
   
namespace App\Http\Controllers\API;
   
use Illuminate\Http\Request;
use App\Http\Controllers\API\BaseController as BaseController;
use App\Models\AppUser;
use App\Models\User;
use Auth;
use Illuminate\Auth\TokenGuard;
use Validator;
use Illuminate\Support\Facades\Hash;
use Illuminate\Validation\ValidationException;
use App\Mail\UserResetPasswordMail;
use App\Models\ResetCodePassword;
use Carbon\Carbon;
use Log;
use URL;
use DB;
use Str;
use Mail;


class RegisterController extends BaseController
{
    /**
     * Register api
     *
     * @return \Illuminate\Http\Response
     */

    public function sendOtp(Request $request){

        $response = array();
        // $userId = Auth::user()->id;
    
        // $users = User::where('id', $userId)->first();
    
        // if ( isset($users['mobile']) && $users['mobile'] =="" ) {
        if ( isset($request->mobile) && $request->mobile =="" ) {
            $response['error'] = 1;
            $response['message'] = 'Invalid mobile number';
            $response['loggedIn'] = 1;
        } else {
    
            $otp = rand(100000, 999999);
            // $MSG91 = new MSG91();
    
            // $msg91Response = $MSG91->sendSMS($otp,$users['mobile']);
    
            // if($msg91Response['error']){
            //     $response['error'] = 1;
            //     $response['message'] = $msg91Response['message'];
            //     $response['loggedIn'] = 1;
            // }else{
    
            Session::put('OTP', $otp);
            $response['error'] = 0;
            $response['message'] = 'Your OTP is created.';
            $response['OTP'] = $otp;
            $response['loggedIn'] = 1;
            // }
        }
        echo json_encode($response);
    }

    public function register(Request $request)
    {
        $validator = Validator::make($request->all(), [
            'name'      => 'required',
            'email'     => 'required|email|unique:users,email',
            'password'  => 'required',
            'phone'     => 'required|unique:users,phone',
        ]);
   
        if($validator->fails()){
            $fail               = [];
            $fail['message']    = 'User Already Exist.';
            return $this->sendError('Validation Error.', $fail);       
        }
        
        $appuser            = new User;
        $appuser->name      = $request->input('name');
        $appuser->email     = $request->input('email');
        $appuser->password  = bcrypt($request->input('password'));
        $appuser->phone     = $request->input('phone');
        $appuser->user_type = 1;
        $appuser->save();
        $success['token']   = $appuser->createToken('auth_token',['*'], now()->addDays(30))->plainTextToken;
        $success['name']    = $appuser->name;   
        return $this->sendResponse($success, 'User register successfully.');
    }
   
    /**
     * Login api
     *
     * @return \Illuminate\Http\Response
     */

    public function login(Request $request){

        if (!Auth::attempt($request->only('phone', 'password'))) {
            return response()->json([
                'status'    => false,
                'message' => 'Invalid login details'
            ], 401);
        }                

        $user                   = User::where('phone', $request['phone'])->firstOrFail();
        $user->tokens()->delete();
        $token                  = $user->createToken('auth_token',['*'], now()->addDays(30))->plainTextToken;
        return response()->json([
            'status'        => true,
            'access_token'  => $token,
            'token_type'    => 'Bearer',
            'message'       => 'User login successful.'
        ]);
    }
    /*
    public function login(Request $request)
    {

        // if(Auth::guard('api')->attempt(['email' => $request->email, 'password' => $request->password])){ 
        //     // $user = Auth::user(); 
        //     // $success['token'] =  $user->createToken('MyApp')->plainTextToken; 
        //     // $success['name'] =  $user->name;
   
        //     // return $this->sendResponse($success, 'User login successfully.');
            
        //     print_r($success);
        // } 
        // else{ 
        //     return $this->sendError('Unauthorised.', ['error'=>'Unauthorised']);
        // } 

        $user = AppUser::where('email', $request->email)->first();
        // print_r("test ".$user);exit;
 
        if (! $user || ! Hash::check($request->password, $user->password)) {
            $success = false;
            // $response['response'] = [
            //     "success" => false,
            //     "error"   => "The provided credentials are incorrect."
            // ]; 

            // return $this->sendResponse($success, 'The provided credentials are incorrect.');
            return $this->sendResponse($success, 'The provided credentials are incorrect.');

            // $responseMessage['success'] = false;
            // // return $this->sendResponse($request->email,'The provided credentials are incorrect.');
            // return responseMessage;
            
        }
        $success['token']   =  $user->createToken('MyApp')->plainTextToken; 
        $success['name']    =  $user->name;

        return $this->sendResponse($success, 'User login successfully.');
        }
    */

    public function user()
    {
        $user               = User::find(Auth::user()->id);
        if($user){
            $data           = [
                                    'status'        => true,
                                    'name'          => $user->name,
                                    'phone'         => $user->phone,
                                    'email'         => $user->email,
                                    
                                ];
            if(Auth::user()->image != ''){
                $data['image']  = 'storage/app/users/'.Auth::user()->image; 
            }else{
                $data['image']  = 'storage/app/users/default.png';
            }
            return response()->json($data);
        }
    }

    public function editUser(Request $request){
        if($request->input('image')){
            $validator = Validator::make($request->all(), [
                'image'         => 'required|mimes:jpeg,jpg,png,gif|max:10000'
            ]);
            if($validator->fails()){
                return $this->sendError('Validation Error.', $validator->errors());       
            }
        }
        $success                    = [];
        $app_user                   = User::find(Auth::user()->id);
        if($app_user){
            if($request->input('name'))
                $app_user->name         = $request->input('name');

            if($request->hasFile('image')){
                $user_image_name             = time().Auth::user()->id.'.'.$request->image->extension();
                if($request->image->storeAs('public/app/users', $user_image_name)){
                    $app_user->image         = $user_image_name;
                }
            }
            $app_user->save();
            $success['status']      = true;
            $success['name']        = $app_user->name;
            return $this->sendResponse($success, 'User Details Changed Successfully.');
        }else{
            return $this->sendError('No Data Found'); 
        }        
    }

    public function userAuthCheck(){
        if(Auth::user()){
            $user                           = User::find(Auth::user()->id);
            $success                        = [
                                                'status'        => true,
                                                'name'          => $user->name,
                                                'phone'         => $user->phone,
                                                'email'         => $user->email,
                                            ];
            return $this->sendResponse($success, 'Authenticated User Details');
        }else{
            return $this->sendError('Authentication Failed, please re-login'); 
        }
    }

    public function fcmToken(Request $request){

        $validator = Validator::make($request->all(), [
            'fcm_token'         => 'required'
        ]);
        if($validator->fails()){
            return $this->sendError('Validation Error.', $validator->errors());       
        }
        $success                        = [];
        $app_user                       = User::find(Auth::user()->id);
        if($app_user){
            if($request->input('fcm_token'))
                $app_user->fcm_token         = $request->input('fcm_token');
            $app_user->save();
            $success['status']          = true;
            $success['fcm_token']        = $app_user->fcm_token;
            return $this->sendResponse($success, 'FCM Token Saved Successfully.');
        }else{
            return $this->sendError('No Data Found'); 
        }        
    }

    public function resetPassword(Request $request){

        $validator = Validator::make($request->all(), [
            'email'         => 'required'
        ]);
        if($validator->fails()){
            return $this->sendError('Validation Error.', $validator->errors());       
        }

        $user                   = User::where(['email' => $request->email, 'user_type'  => 1])->first();
        if (!$user) {
            return $this->sendError('User Not Found!');     
        }
        if($user){
            ResetCodePassword::insert([
                                                    'email'         => $request->email,
                                                    'token'         => bcrypt(Str::random(64)),
                                                    'created_at'    => Carbon::now()
                                                ]);
            $tokenData              = ResetCodePassword::where('email', $request->email)->first();
            $link                   = config('base_url') . 'apppassword/reset?token=' . $tokenData->token . '&email=' . urlencode($user->email);
            
            $welcomeEmail       = new UserResetPasswordMail($user->id, $user->name, $user->email, $link);
            Mail::to($user->email)->send($welcomeEmail);

            $success['status']      = true;
            return $this->sendResponse($success, 'Password reset mail has been sent.');
        }
    }

    public function resetAppPassword(Request $request){

        $validator = Validator::make($request->all(), [
            'phone_number'  => 'required'
        ]);
        if($validator->fails()){
            return $this->sendError('Validation Error.', $validator->errors());       
        }

        $user                   = User::where(['phone' => $request->phone_number, 'user_type'  => 1])->first();
        if (!$user) {
            return $this->sendError('User Not Found!');     
        }
        $validator = Validator::make($request->all(), [
                'password' => 'min:4|required_with:newpassword|same:newpassword',
                'newpassword' => 'min:4'
        ]);

        if($user){
            $password               = Hash::make($request->password);
            $user->password         = $password;
            $user->save();
            
            $success['status']      = true;
            return $this->sendResponse($success, 'Password Changed.');
        }
    }

    private function sendResetEmail($email, $token)
    {
        $user                   = DB::table('users')->where('email', $email)->first();
        //try {
            
            return;
        /*
        } catch (\Exception $e) {
            return false;
        }
        */
    }
}