<?php

namespace App\Http\Controllers\Auth;

use App\Models\Company;
use App\Models\CompanyUser;
use App\Models\User;
use App\Http\Controllers\Controller;
use App\Providers\RouteServiceProvider;
use Illuminate\Foundation\Auth\AuthenticatesUsers;
use Session;
use Illuminate\Http\Request;
use Auth;


class LoginController extends Controller
{
    /*
    |--------------------------------------------------------------------------
    | Login Controller
    |--------------------------------------------------------------------------
    |
    | This controller handles authenticating users for the application and
    | redirecting them to your home screen. The controller uses a trait
    | to conveniently provide its functionality to your applications.
    |
    */

    use AuthenticatesUsers;

    /**
     * Where to redirect users after login.
     *
     * @var string
     */
    protected $redirectTo = RouteServiceProvider::DASHBOARD;

    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct()
    {
        $this->middleware('guest')->except('logout');
    }

    public function login(Request $request)
    {
        $credentials = $request->only('email', 'password');
        
        if (Auth::attempt($credentials)) {
            $user=Auth::user();
            $company_user=CompanyUser::where('user_id',$user->id)->first();
            if(!$company_user){
                Auth::logout();
                return redirect('login');
            }
            $company=Company::where('id',$company_user->company_id)->first();
            // echo $company_user->company_id;
            session(['company'=>$company_user->company_id,'company_name' => $company->company_name,'company_logo' => $company->company_logo,'logged_in_company'=>$company_user->company_id]);
            User::where('id', $user->id)->update(['invitation_token' =>  null]);
            return redirect()->intended('dashboard');
        }
        return back()->withErrors(['email' => 'Email or password are incorrect.']);
    }
}
