<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Session;
use App\Models\Company;
use App\Models\User;
use App\Models\CompanyUser;
use App\Models\Chat;
use App\Models\ChatMessage;
use App\Models\ScannedProduct;
use DB;
use Auth;
use Log;
use Str;
use URL;
class ChatController extends Controller
{
    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct()
    {
        $this->middleware('auth');
    }

    /**
     * Show the application dashboard.
     *
     * @return \Illuminate\Contracts\Support\Renderable
     */
    public function index()
    {
        //$chat_list                      = Chat::where('receiver',Auth::user()->id)->get();
        $session_company            = Session::get('company');
        $all_companies              = Company::pluck('company_name','id')->all();
        return view('chats.index',compact('all_companies'));
    }

    public function list(Request $request){
        try {

            if($request['company_id']==null)   {
                $company                                    = 1;
            }else {
                $company                                    = $request['company_id'];
            }
            $result             = Chat::with('from')->where(['company_id' => $company])->orderBy('updated_at','desc')->get();
            $chats               = [];
            foreach($result as $chat){
                if($chat->from){
                    $chats[]        =  $chat;
                }
                
            }
            $datatables         = datatables()->of($chats)->addColumn('sl_no', function () {
                                        return '';
                                    });
            $datatables         = $datatables->addColumn('name', function ($chats) {
                                        if($chats->from){
                                            return '<a class="De_view" href="' . route("users.show", $chats->from->id) . '" title="Show" >'.$chats->from->name .'</a>';
                                        }else{
                                            return '-- --';
                                        }
                                    });
            $datatables         = $datatables->addColumn('product_name', function ($chats) {

                                        $temp_html  = '';
                                        $temp_html .= '<div class="col-md-3" style="float:left">';
                                        $temp_html .= '<img src="'.URL::asset('../storage/app/images/'.$chats->product->product_image).'" width="60"/>';
                                        $temp_html .= '</div>';
                                        $temp_html .= '<div class="col-md-9" style="float:left">';
                                        $temp_html .='<div class="pro_details_box">';
                                        $temp_html .='<div class="prod_code">'.$chats->product->product_code.'</div>';
                                        $temp_html .='<div class="separator">|</div>';
                                        $temp_html .='<div class="prod_name"><a class="De_view" href="' . route("products.show", $chats->product->id) . '" title="Show" >'.$chats->product->product_name.'</a></div>';
                                        if($chats->product->brand_name){
                                        $temp_html .='<div class="separator">|</div>';
                                        $temp_html .='<div class="prod_brand">'.$chats->product->brand_name.'</div>';
                                        }
                                        if($chats->product->model_number){
                                        $temp_html .='<div class="separator">|</div>';
                                        $temp_html .='<div class="prod_modeln">'.$chats->product->model_number.'</div>';
                                        }
                                        if($chats->product->category){
                                            $temp_html .='<div class="separator">|</div>';
                                            $temp_html .='<div class="prod_category">'.$chats->product->category->category.'</div>';
                                        }
                                        $temp_html .='</div>';
                                        $temp_html .='<div style="font-size:13px;">'.$chats->product->description.'</div> ';
                                        $temp_html .='</div>';

                                        return $temp_html;
                                    });
            $datatables         = $datatables->addColumn('chat_against', function ($chats) {
                                        if($chats->chat_on == 0){
                                            return '<strong>Seller</strong>';
                                        }elseif($chats->chat_on == 1){
                                            return '<strong>Product</strong>';
                                        }else{
                                            return;
                                        }
                                    });
            /*
            $datatables         = $datatables->addColumn('descriptions', function ($chats) {
                                        return $chats->product->descriptions;
                                    });
            */

            $datatables         = $datatables->addColumn('batch_no', function ($chats) {
                                        return explode('-',$chats->code)[3];
                                    });
            $datatables         = $datatables->addColumn('qr_code', function ($chats) {
                                        return $chats->code;
                                    });

            $datatables         = $datatables->addColumn('auth_status', function ($chats) {
                                    $auth_details           = ScannedProduct::where(['user_id' => $chats->creator, 'code' =>  $chats->code])->first();
                                        if($auth_details ){
                                            return '<i class="fas fa-thumbs-up fa-2xl" style="color:green"></i>';
                                        }else{
                                            return '<i class="fas fa-thumbs-down fa-2xl" style="color:red"></i>';
                                        }
                                        return $chats->code;
                                    });

            $datatables         = $datatables->addColumn('type', function ($chats) {
                                        if($chats->chat_type == 1){
                                            $chatType           = 'Complaint';
                                        }else{
                                            $chatType           = 'Chat/Feedback';

                                        }
                                        if(sizeof($chats->unreadedMessagesAppUser) > 0){
                                            return '<a class="De_view" href="' . route("chat.show", $chats->id) . '" title="Show" >'.$chatType.'<span class="badge badge-danger">'.sizeof($chats->unreadedMessagesAppUser).'</span></a>';
                                        }else{
                                            return '<a class="De_view" href="' . route("chat.show", $chats->id) . '" title="Show" >'.$chatType.'</a>';
                                        }
                                    });
            
            $datatables         = $datatables->addColumn('date', function ($chats) {
                                        return date('d-m-Y h:i A', strtotime($chats->date));
                                    });
            /*
            $datatables         = $datatables->addColumn('actions', function ($chats) {
                                        $actions            ='<div class="action-icons">';
                                        $actions            .= '<a href="' . route("chat.show", $chats->id) . '" title="Show" ><i class="fas fa-eye"></i></a>&nbsp;</div>';
                                        return $actions;
                                    });
            */
            $datatables = $datatables->escapeColumns([])->toJson();
                return $datatables;
        }
        catch (\Exception $e) {
            Log::error("Error in CategoriesController categoryList :- " . $e->getMessage());
        } 

    }

    public function show($id)
    {
        $chat_details                       = Chat::find($id);
        foreach($chat_details->messages as $message){
            if($message->type == 0  && $message->status == 1){
                $temp_message               = ChatMessage::find($message->id);
                $temp_message->status       = 0;
                $temp_message->save(); 
            }
        }
        return view('chats.show', compact('chat_details'));
    }

    public function save(Request $request, $id)
    {
        $chat_details           = Chat::find($id);
        if($request->input('message') || $request->hasFile('messageFile')){
            if($chat_details){
                $new_message                = new ChatMessage();
                $new_message->chat_id       = $chat_details->id;
                $new_message->date          = date('Y-m-d H:i:s');
                $new_message->status        = 1;
                if($request->hasFile('messageFile')){
                    $chat_file_file                             = time().Auth::user()->id.'.'.$request->messageFile->extension();
                    if($request->messageFile->storeAs('public/app/chat_files', $chat_file_file)){
                        $new_message->chat_file                = $chat_file_file;
                    }
                    $new_message->message   = '';
                }else{
                    $new_message->message       = $request->input('message');
                }
                
                $new_message->type          = 1;
                $new_message->user_id       = Auth::user()->id;
                $new_message->save();
                $chat_details->updated_at   = date('Y-m-d H:i:s');
                $chat_details->save();
            }
        }
        return redirect('chat-details/'.$chat_details->id);
    }

    public function resetCompany(Request $request) {
        try {
            if(Session::get('company')){
                Session::forget('company');
                Session::forget('company_name');
                $company=Company::where('id',1)->first();
                session(['company'=>1,'company_name' => $company->company_name]);
        
            }
            return redirect('companies');
        }
        catch (\Exception $e) {
            Log::error("Error in HomeController setCompany :- " . $e->getMessage());
        }
    }
}
