<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\Order;
use App\Models\OrderProductDetil;
use App\Models\User;
use App\Models\Product;
use App\Models\Company;
use App\Models\Categories;
use App\Models\OrderBatch;
use Spatie\Permission\Models\Permission;
use App\Mail\OrderNotification;
use App\Models\BatchNumber;
use Log;
use Redirect;
use Auth;
use Session;
use DB;
use PDF;
use Mail;

class OrderController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */

    function __construct()
    {
        $this->company_id       = '';
        $this->loged_company    = 0;
        $this->middleware('permission:orders-list|orders-create|orders-edit|orders-delete', ['only' => ['index','store']]);
        $this->middleware('permission:orders-create', ['only' => ['create','store']]);
        $this->middleware('permission:orders-edit', ['only' => ['edit','update']]);
        $this->middleware('permission:orders-delete', ['only' => ['destroy']]);
    }

    public function index(Request $request)
    {
        $session_company            = Session::get('company');
        $all_companies              = Company::pluck('company_name','id')->all();
        /*
            if(Auth::user()->id != 1){            
                $companies              = DB::table('company_users')
                                            ->where('user_id',Auth::user()->id)->first();
                if($companies){
                    $company            = Company::find($companies->company_id);
                } else{
                    $company                    = Company::find($session_company);
                }
                $orders_query               = Order::query();
                $orders_query->with('products');
                if($company->id != 1){
                    //dd('ddcnjik');
                    //$orders_query->where('company_id',$session_company);
                    /*
                    $temp_search_array          = [];
                    if(Auth::user()->hasRole(3)){
                        $temp_search_array['order_placed']      = Auth::user()->id;
                    }
                    if(Auth::user()->hasRole(4)){
                        $temp_search_array['verifier']          = Auth::user()->id;
                    }
                    if(Auth::user()->hasRole(5)){
                        $temp_search_array['signatory']         =  Auth::user()->id;
                    }

                    if(Auth::user()->hasRole(3) || Auth::user()->hasRole(4) || Auth::user()->hasRole(5) ){
                        $orders_query->where(function($orders_query) use ($temp_search_array){
                            return $orders_query->orWhere($temp_search_array);
                        });
                    }* /
                }else{
                    $companies              = DB::table('company_users')
                                            ->where('user_id',Auth::user()->id)->first();
                    if($companies){
                        $company            = Company::find($companies->company_id);
                    } else{
                        $company                    = Company::find($session_company);
                    }
                    $temp_search_array                          = [];
                    if(Auth::user()->hasRole(3)){
                        $temp_search_array['order_placed']      = Auth::user()->id;
                    }
                    if(Auth::user()->hasRole(4)){
                        $temp_search_array['verifier']          = Auth::user()->id;
                    }
                    if(Auth::user()->hasRole(5)){
                        $temp_search_array['signatory']         =  Auth::user()->id;
                    }

                    if(Auth::user()->hasRole(3) || Auth::user()->hasRole(4) || Auth::user()->hasRole(5) ){
                        $orders_query->where(function($orders_query) use ($temp_search_array){
                            return $orders_query->orWhere($temp_search_array);
                        });
                    }
                    $orders_query->orWhere([['print_status', 1], ['status',3], ['company_print_status' ,'>' , 0] ]);
                }
                $orders_query->where(['company_id'=>$session_company]);
                
                $orders                 = $orders_query->orderBy('id','DESC')->paginate(10);
            }else{
                    $companies              = DB::table('company_users')
                                            ->where('user_id',Auth::user()->id)->first();
                    if($companies){
                        $company            = Company::find($companies->company_id);
                    } else{
                        $company                    = Company::find($session_company);
                    }
                $orders                 = Order::with('products')->orderBy('id','DESC')->paginate(10);
            }
        */
        return view('orders.index',compact('all_companies'))
            ->with('i', ($request->input('page', 1) - 1) * 10);
    }


    public function orderList(Request $request) {
        try {
            if($request['company_id']==null)   {
                $company                                    = 0;
            }else {
                $company                                    = $request['company_id'];
            }

            $company_id                                     = $company;
            $this->company_id                               = $company_id;

            $companies                                      = DB::table('company_users')
                                                                ->where('user_id',Auth::user()->id)->first();
            if($companies){
                $this->loged_company                        = Company::find($companies->company_id)->id;
            } else{
                $this->loged_company                        = $this->company_id;
            }

            $orders_query                                   = Order::query();
            $orders_query->with('products');
            if($company_id  == 1){
                
            }else{
                $temp_search_array                          = [];
                if(Auth::user()->hasRole(3)){
                    $temp_search_array['order_placed']      = Auth::user()->id;
                }
                if(Auth::user()->hasRole(4)){
                    $temp_search_array['verifier']          = Auth::user()->id;
                }
                if(Auth::user()->hasRole(5)){
                    $temp_search_array['signatory']         =  Auth::user()->id;
                }

                if(Auth::user()->hasRole(3) || Auth::user()->hasRole(4) || Auth::user()->hasRole(5) ){
                    $orders_query->where(function($orders_query) use ($temp_search_array){
                        return $orders_query->orWhere($temp_search_array);
                    });
                }
                $orders_query->orWhere([['print_status', 1], ['status',3], ['company_print_status' ,'>' , 0] ]);
            }
            $orders_query->where(['company_id'=>$company_id]);
            
            $orders                     = $orders_query->orderBy('id','DESC')->get();
            $orders                     = collect($orders);
            $datatables                 = datatables()->of($orders)->addColumn('sl_no', function () {
                                                return '';
                                            });
            $datatables                 = $datatables->addColumn('order_id', function ($orders) {
                                                $temp_html = '<a href="'.route('orders.details',$orders->id).'" title="Details">#'.$orders->id.'</a>';
                                                if($orders->status == 1 &&  $orders->print_status == 0){
                                                    $temp_html .= '<span class="right pen_noti">&nbsp;</span>';
                                                }elseif($orders->company_print_status == 1 &&  $orders->print_status == 1){
                                                    if($this->loged_company  != 1 ){
                                                    }elseif($orders->company_verifier && $orders->company_approver ){
                                                        $temp_html .= '<span class="right pen_noti">&nbsp;</span>';
                                                    }
                                                }
                                                return $temp_html;
                                            });
            $datatables                 = $datatables->addColumn('date', function ($orders) {
                                                return date("d-M-Y", strtotime($orders->date));
                                            });
            $datatables                 = $datatables->addColumn('total_labels', function ($orders) {
                                                return $orders->products->sum('label_count');
                                            });
            $datatables                 = $datatables->addColumn('verifier', function ($orders) {
                    $temp_html          = '';
                                            if($this->loged_company == 1 && $orders->print_status == 1){
                                                $temp_html      .= ($orders->companyVerifier?$orders->companyVerifier->name: '--');
                                            }else{
                                                $temp_html      .= ($orders->userVerifier?$orders->userVerifier->name: '--');
                                            }

                                            return $temp_html;
                                            });
            $datatables                 = $datatables->addColumn('approver', function ($orders ) {
                    $temp_html          = '';
                                            if($this->loged_company == 1 && $orders->print_status == 1){
                                                $temp_html      .= ($orders->companyApprover?$orders->companyApprover->name: '--');
                                            }else{
                                                $temp_html      .= ($orders->approver?$orders->approver->name: '--');
                                            }
                                            return $temp_html;
                                        }); 
            $datatables                 = $datatables->addColumn('status', function ($orders ) {
                            if($orders->status == -1 && $orders->print_status == 0 ){
                                $temp_html = '<small class="badge badge-danger">Approver Rejection</small>'; 
                            }
                            elseif($orders->status == 0  && $orders->print_status == 0 ){
                                $temp_html = '<small class="badge badge-danger">Rejected</small>';            
                            }
                            elseif($orders->status == 1 &&  $orders->print_status == 0){
                                $temp_html = '<small class="badge badge-primary">Veification Pending</small>';
                            }
                            elseif($orders->status == 2 &&  $orders->print_status == 0){
                                $temp_html = '<small class="badge badge-secondary">Verified</small>';
                            }
                            elseif($orders->status == 3 &&  $orders->print_status == 0){
                                $temp_html = '<small class="badge badge-info">Approved</small>';
                            }
                            elseif($orders->status == 4 &&  $orders->print_status == 0){
                                $temp_html = '<small class="badge badge-success">Printed</small>';
                            }
                            elseif($orders->company_print_status == -1 && $orders->print_status == 1 ){
                                $temp_html = '<small class="badge badge-danger">Company Approver Rejection</small>';
                            }
                            elseif($orders->company_print_status == 0  && $orders->print_status == 1 ){
                                $temp_html = '<small class="badge badge-danger">Company Rejected</small>';
                            }elseif($orders->company_print_status == 1 &&  $orders->print_status == 1){
                                $temp_html ='<small class="badge badge-primary">';
                                if($this->loged_company  != 1 ){
                                    $temp_html .= 'Transfered to getOroigin';
                                }elseif($orders->company_verifier && $orders->company_approver ){
                                    $temp_html .= 'Verification Pending';

                                }else{
                                    $temp_html .= 'New Order';
                                }
                                $temp_html .= '</small>';
                            }elseif($orders->company_print_status == 2 &&  $orders->print_status == 1){
                                $temp_html ='<small class="badge badge-secondary">';
                                if($this->loged_company  != 1) {
                                    $temp_html .= 'Company Verified';
                                }else{
                                    $temp_html .= 'Verified';
                                }
                                $temp_html .= '</small>';
                            }
                            elseif($orders->company_print_status == 3 &&  $orders->print_status == 1){
                                $temp_html ='<small class="badge badge-info">';
                                  if($this->loged_company  != 1) 
                                    $temp_html .='Company ';
                                  else
                                    $temp_html .='Approved';

                                $temp_html .='</small>';
                            }
                            elseif($orders->company_print_status == 4 &&  $orders->print_status == 1)
                                $temp_html ='<small class="badge badge-success">Printed</small>';

                        return $temp_html;
                });

            $datatables                 = $datatables->addColumn('actions', function ($orders) {                
                $temp_html              = '<div class="action-icons"> ';
                            if($orders->status == 1 && Auth::user()->hasRole(3) && ($orders->order_placed == Auth::user()->id)){
                                    $temp_html .='<a href="'.route('orders.edit',$orders->id).'" title="Edit">
                                      <i class="fas fa-edit"></i>
                                    </a>
                                    &nbsp;';
                                }
                            elseif($orders->status == 3 && $this->loged_company  == 1 && Auth::user()->hasRole(3) && $orders->company_print_status  == 1 && $orders->print_status  == 1){
                                $temp_html .= '<a href="'.route('orders.edit',$orders->id).'" title="Edit">
                                                <i class="fas fa-edit"></i>
                                                </a>';
                                }
                                if($this->loged_company  == 1 && Auth::user()->hasRole(3) && $orders->company_print_status  == 1 && $orders->companyVerifier){
                                    $temp_html .='<a href="'.route('orders.show',$orders->id).'" title="Verify">
                                      <i class="fa fa-check-square-o"></i>
                                    </a>';
                                }
                                if($this->loged_company  != 1 && Auth::user()->hasRole(3) && $orders->status  == 1 && $orders->userVerifier && $orders->print_status == 0){
                                    $temp_html .='<a href="'.route('orders.show',$orders->id).'" title="Verify">
                                      <i class="fa fa-check-square-o"></i>
                                    </a>';
                                }
                                $temp_html .='&nbsp;';
                            if(Auth::user()->hasRole(5) && ($orders->status == 2 ||$orders->status == -1 ) && ($orders->signatory == Auth::user()->id)){
                                $temp_html .='<a href="'.route('orders.approvedetails',[$orders->id]).'" title="Approve">
                                      <i class="fas fa-check"></i>
                                    </a>
                                    &nbsp;';
                                }
                            elseif(Auth::user()->hasRole(5) && $this->loged_company  == 1 && $orders->print_status  == 1 && ($orders->company_print_status == 2 ||$orders->company_print_status == -1 ) && ($orders->company_approver == Auth::user()->id)){
                                $temp_html .='<a href="'.route('orders.approvedetails',[$orders->id]).'" title="Approve">
                                  <i class="fas fa-check"></i>
                                </a>
                                &nbsp;';
                            }   

                            if((Auth::user()->id == $orders->receiver && $orders->status == 3 && $orders->print_status == 0)){
                                $temp_html .='<a href="'.route('orders.batchs',[$orders->id]).'" title="Print">
                                  <i class="fas fa-print"></i> 
                                </a>';
                            }
                            elseif($this->loged_company  == 1 && $orders->status == 3 && $orders->company_print_status == 3 && $orders->print_status == 1 && Auth::user()->hasRole(6)){
                                $temp_html .='<a href="'.route('orders.batchs',[$orders->id]).'" title="Print">
                                  <i class="fas fa-print"></i> 
                                </a>';
                            }
                            $temp_html .='</div>';
                    return $temp_html;
            });
            $datatables             = $datatables->escapeColumns([])->toJson();
            return $datatables;
        }
        catch (\Exception $e) {
            Log::error("Error in OrderController Orderist :- " . $e->getMessage());
        } 
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
    */
    public function create()
    {
        if(Auth::user()->id){
            
            $companies              = DB::table('company_users')
                                        ->where('user_id',Auth::user()->id)->first();
            if($companies){
                $company            = Company::find($companies->company_id);
            } 


            if($company->id == 1){
                if(Session::has('company')){
                    $company            = Company::find(Session::get('company'));
                }
            } 
            $products               = Product::with('category')->where('company_id', $company->id)->get();
            $all_company_verifires  = DB::table('model_has_roles')
                                        ->where('role_id',4)->get();
            $all_verifires_ids      = [];
            foreach($all_company_verifires as $temp_verifier){
                $all_verifires_ids[]= $temp_verifier->model_id;
            }

            $company_verifiers      = DB::table('company_users')
                                        ->where('company_id',$company->id)
                                        ->whereIn('user_id',$all_verifires_ids)
                                        ->get();
            $verifier_ids           = [];
            foreach($company_verifiers as $com_verifier){
                $verifier_ids[]      = $com_verifier->user_id;
            }

            $all_company_approvers  = DB::table('model_has_roles')
                                        ->where('role_id',5)->get();
            $all_approvers_ids      = [];
            foreach($all_company_approvers as $temp_approver){
                $all_approvers_ids[]= $temp_approver->model_id;
            }

            $company_approvers      = DB::table('company_users')
                                        ->where('company_id',$company->id)
                                        ->whereIn('user_id',$all_approvers_ids)
                                        ->get();
            $approver_ids           = [];
            foreach($company_approvers as $com_approver){
                $approver_ids[]    = $com_approver->user_id;
            }

            $verifiers              = User::whereIn('id', $verifier_ids)->get();
            $approvers              = User::whereIn('id', $approver_ids)->get();
        }
        // }else{
            
            //$products               = Product::with('category')->get();

        //     $all_company_verifires  = DB::table('model_has_roles')
        //                                 ->where('role_id',4)->get();
        //     $all_verifires_ids      = [];
        //     foreach($all_company_verifires as $temp_verifier){
        //         $all_verifires_ids[]= $temp_verifier->model_id;
        //     }

        //     $company_verifiers      = DB::table('company_users')
        //                                 ->whereIn('user_id',$all_verifires_ids)
        //                                 ->get();
        //     $verifier_ids           = [];
        //     foreach($company_verifiers as $com_verifier){
        //         $verifier_ids[]      = $com_verifier->user_id;
        //     }

        //     $all_company_approvers  = DB::table('model_has_roles')
        //                                 ->where('role_id',5)->get();
        //     $all_approvers_ids      = [];
        //     foreach($all_company_approvers as $temp_approver){
        //         $all_approvers_ids[]= $temp_approver->model_id;
        //     }

        //     $company_approvers      = DB::table('company_users')
        //                                 ->whereIn('user_id',$all_approvers_ids)
        //                                 ->get();
        //     $approver_ids           = [];
        //     foreach($company_approvers as $com_approver){
        //         $approver_ids[]    = $com_approver->user_id;
        //     }

        //     $verifiers              = User::whereIn('id', $verifier_ids)->get();
        //     $approvers              = User::whereIn('id', $approver_ids)->get();
        // }
        return view('orders.create', compact('products','verifiers','approvers'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $this->validate($request, [
                'product_name'  => 'required',
                'label_count'   => 'required',
                'product_id'    => 'required',
        ]);

        if(Auth::user()->id != 1){
            $companies              = DB::table('company_users')
                                        ->where('user_id',Auth::user()->id)->first();
            if($companies)
            {
                $company            = Company::find($companies->company_id);
            }   
            $companies              = Company::select('id','company_name')
                                        ->where('id', $company->id)->get();
            $products               = Product::where('company_id', $company->id)->get();
            $all_company_verifires  = DB::table('model_has_roles')
                                        ->where('role_id',4)->get();
            $all_verifires_ids      = [];
            foreach($all_company_verifires as $temp_verifier){
                $all_verifires_ids[]= $temp_verifier->model_id;
            }
            $company_verifiers      = DB::table('company_users')
                                        ->where('company_id',$company->id)
                                        ->whereIn('user_id',$all_verifires_ids)
                                        ->get();
            $verifier_ids           = [];
            foreach($company_verifiers as $com_verifier){
                $verifier_ids[]      = $com_verifier->user_id;
            }
            $all_company_approvers  = DB::table('model_has_roles')
                                        ->where('role_id',5)->get();
            $all_approvers_ids      = [];
            foreach($all_company_approvers as $temp_approver){
                $all_approvers_ids[]= $temp_approver->model_id;
            }

            $company_approvers      = DB::table('company_users')
                                        ->where('company_id',$company->id)
                                        ->whereIn('user_id',$all_approvers_ids)
                                        ->get();
            $approver_ids           = [];
            foreach($company_approvers as $com_approver){
                $approver_ids[]    = $com_approver->user_id;
            }

            $verifiers              = User::whereIn('id', $verifier_ids)->get();
            $approvers              = User::whereIn('id', $approver_ids)->get();
        }else{
            $products               = Product::get();

            $all_company_verifires  = DB::table('model_has_roles')
                                        ->where('role_id',4)->get();
            $all_verifires_ids      = [];
            foreach($all_company_verifires as $temp_verifier){
                $all_verifires_ids[]= $temp_verifier->model_id;
            }

            $company_verifiers      = DB::table('company_users')
                                        ->whereIn('user_id',$all_verifires_ids)
                                        ->get();
            $verifier_ids           = [];
            foreach($company_verifiers as $com_verifier){
                $verifier_ids[]      = $com_verifier->user_id;
            }

            $all_company_approvers  = DB::table('model_has_roles')
                                        ->where('role_id',5)->get();
            $all_approvers_ids      = [];
            foreach($all_company_approvers as $temp_approver){
                $all_approvers_ids[]= $temp_approver->model_id;
            }

            $company_approvers      = DB::table('company_users')
                                        ->whereIn('user_id',$all_approvers_ids)
                                        ->get();
            $approver_ids           = [];
            foreach($company_approvers as $com_approver){
                $approver_ids[]    = $com_approver->user_id;
            }

            $verifiers              = User::whereIn('id', $verifier_ids)->get();
            $approvers              = User::whereIn('id', $approver_ids)->get();
        }
        $product_ids                                        = $request->input('product_id');
        $product_labels                                     = $request->input('label_count');
        $verifier                                           = User::find($request->input('verifier'));
        $approver                                           = User::find($request->input('approver'));
        $tempory_order_data                                 = [];
        foreach($product_ids as $t_key => $p_id)
        {
            if($p_id != ''){
                $product                                        = Product::find($p_id);
                if($product){
                    $temp_items                                 = [
                                                                    'product_id'        => $product->id,
                                                                    'product_name'      => $product->product_name,
                                                                    'label_count'       => $product_labels[$t_key],
                                                                    ];  
                    if(!$temp_items['label_count']){
                        $temp_items['label_count']              = 100;
                    }
                    $tempory_order_data['product_details'][]    = $temp_items;
                }
            }
        }      
        
        $tempory_order_data['approver_id']                  = $approver->id;
        $tempory_order_data['approver_name']                = $approver->name;
        $tempory_order_data['verifier_id']                  = $verifier->id;
        $tempory_order_data['verifier_name']                = $verifier->name;
        $tempory_order_data['order_note']                   = $request->input('order_note');
        
        if(Session::get('order_details')){
            Session::forget('order_details');
            Session::put('order_details', $tempory_order_data);
        }else{
            Session::put('order_details', $tempory_order_data);
        }
        return view('orders.summary',compact('tempory_order_data','verifiers','approvers'));
    }

   /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */

    

     public function details($id)
     {
 
         $orders_query               = Order::query();
         $orders_query->with('products');
 
         $companies              = DB::table('company_users')
                                         ->where('user_id',Auth::user()->id)->first();
         if($companies){
             $company            = Company::find($companies->company_id);
         }
 
         $all_company_receivers      = DB::table('model_has_roles')
                                         ->where('role_id',6)->get();
         $all_receivers_ids          = [];
         foreach($all_company_receivers as $temp_receiver){
             $all_receivers_ids[]    = $temp_receiver->model_id;
         }
 
         $company_receivers         = DB::table('company_users')
                                         ->where('company_id',$company->id)
                                         ->whereIn('user_id',$all_receivers_ids)
                                         ->get();
         $receiver_ids           = [];
         foreach($company_receivers as $com_receiver){
             $receiver_ids[]    = $com_receiver->user_id;
         }
 
         $receivers              = User::whereIn('id', $receiver_ids)->get();
 
         if(Auth::user()->hasRole(3) || Auth::user()->hasRole(4) || Auth::user()->hasRole(5) || Auth::user()->hasRole(6)){
             $orders_query               = Order::query();
             $orders_query->with('products');
 
             $temp_search_array          = [];
             if($company->id != 1){
                 if(Auth::user()->hasRole(3)){
                     $temp_search_array['order_placed']      = Auth::user()->id;
                 }
                 if(Auth::user()->hasRole(4)){
                     $temp_search_array['verifier']          = Auth::user()->id;
                 }
                 if(Auth::user()->hasRole(5)){
                     $temp_search_array['signatory']         =  Auth::user()->id;
                 }
 
                 if(Auth::user()->hasRole(3) || Auth::user()->hasRole(4) || Auth::user()->hasRole(5) ){
                     $orders_query->where(function($orders_query) use ($temp_search_array){
                         return $orders_query->orWhere($temp_search_array);
                     });
                 }
             }
             $order                  = $orders_query->find($id);
             //die('asdkcj ');
             return view('orders.details', compact('order','receivers', 'company'));
         }        
 
         if(Auth::user()->hasRole(6)){
             $company                        = DB::table('company_users')
                                             ->where('user_id',Auth::user()->id)->first();
 
             if($company->company_id != 1)
                 $orders_query->where('company_id', $company->company_id);
 
             $order                          = $orders_query->find($id);
             return view('orders.details', compact('order','receivers', 'company'));
         }
 
         if(Auth::user()->id == 1){
             $order          = $orders_query->find($id);
         }
 
         if(!$order  || ($order->creator->id != Auth::user()->id) ||Auth::user()->id == 1 ){
             return redirect('orders')->with('success', 'Data Not Found!');
         }
         $order          = $orders_query->find($id);
 
         return view('orders.details', compact('order','receivers', 'company')); 
     }
     
    public function show($id)
    {

        $orders_query               = Order::query();
        $orders_query->with('products');

        $companies              = DB::table('company_users')
                                        ->where('user_id',Auth::user()->id)->first();
        if($companies){
            $company            = Company::find($companies->company_id);
        }

        $all_company_receivers      = DB::table('model_has_roles')
                                        ->where('role_id',6)->get();
        $all_receivers_ids          = [];
        foreach($all_company_receivers as $temp_receiver){
            $all_receivers_ids[]    = $temp_receiver->model_id;
        }

        $company_receivers         = DB::table('company_users')
                                        ->where('company_id',$company->id)
                                        ->whereIn('user_id',$all_receivers_ids)
                                        ->get();
        $receiver_ids           = [];
        foreach($company_receivers as $com_receiver){
            $receiver_ids[]    = $com_receiver->user_id;
        }

        $receivers              = User::whereIn('id', $receiver_ids)->get();

        if(Auth::user()->hasRole(3) || Auth::user()->hasRole(4) || Auth::user()->hasRole(5) || Auth::user()->hasRole(6)){
            $orders_query               = Order::query();
            $orders_query->with('products');

            $temp_search_array          = [];
            if($company->id != 1){
                if(Auth::user()->hasRole(3)){
                    $temp_search_array['order_placed']      = Auth::user()->id;
                }
                if(Auth::user()->hasRole(4)){
                    $temp_search_array['verifier']          = Auth::user()->id;
                }
                if(Auth::user()->hasRole(5)){
                    $temp_search_array['signatory']         =  Auth::user()->id;
                }

                if(Auth::user()->hasRole(3) || Auth::user()->hasRole(4) || Auth::user()->hasRole(5) ){
                    $orders_query->where(function($orders_query) use ($temp_search_array){
                        return $orders_query->orWhere($temp_search_array);
                    });
                }
            }
            $order                  = $orders_query->find($id);
            
            if($order){
                return view('orders.show', compact('order','receivers', 'company'));
            }else{
                return redirect('orders')->with('fail', 'You are not permited to do this operation right now!');
            }
        }        

        if(Auth::user()->hasRole(6)){
            $company                        = DB::table('company_users')
                                            ->where('user_id',Auth::user()->id)->first();

            if($company->company_id != 1)
                $orders_query->where('company_id', $company->company_id);

            $order                          = $orders_query->find($id);
            return view('orders.show', compact('order','receivers', 'company'));
        }

        if(Auth::user()->id == 1){
            $order          = $orders_query->find($id);
        }

        if(!$order  || ($order->creator->id != Auth::user()->id) ||Auth::user()->id == 1 ){
            return redirect('orders')->with('fail', 'Data Not Found!');
        }
        $order          = $orders_query->find($id);

        return view('orders.show', compact('order','receivers', 'company')); 
    }

    public function edit($id)
    {

        $order                          = Order::with('products')->find($id);
        /*
        if(!$order  || ($order->creator->id != Auth::user()->id) || $order->status != 1){
            return redirect('orders')->with('success', 'Data Not Found!');
        }
        */
        if(Auth::user()->id){

            $companies                  = DB::table('company_users')
                                            ->where('user_id',Auth::user()->id)->first();
            if($companies)
            {
                $company                = Company::find($companies->company_id);
            }   
            $companies                  = Company::select('id','company_name')
                                        ->where('id', $company->id)->get();
            $companies              = DB::table('company_users')
                                        ->where('user_id',Auth::user()->id)->first();
            if($companies){
                $company            = Company::find($companies->company_id);
            }  
            if($company->id == 1){
                /*
                if(Session::has('company')){
                    $company            = Company::find(Session::get('company'));
                }*/
            } 

            $products                   = Product::with('category')->where('company_id', $company->id)->get();
            $all_company_verifires      = DB::table('model_has_roles')
                                        ->where('role_id',4)->get();
            $all_verifires_ids          = [];
            foreach($all_company_verifires as $temp_verifier){
                $all_verifires_ids[]    = $temp_verifier->model_id;
            }

            $company_verifiers          = DB::table('company_users')
                                            ->where('company_id',$company->id)
                                            ->whereIn('user_id',$all_verifires_ids)
                                            ->get();
            $verifier_ids               = [];
            foreach($company_verifiers as $com_verifier){
                $verifier_ids[]         = $com_verifier->user_id;
            }
            $all_company_approvers      = DB::table('model_has_roles')
                                            ->where('role_id',5)->get();
            $all_approvers_ids          = [];
            foreach($all_company_approvers as $temp_approver){
                $all_approvers_ids[]    = $temp_approver->model_id;
            }

            $company_approvers          = DB::table('company_users')
                                            ->where('company_id',$company->id)
                                            ->whereIn('user_id',$all_approvers_ids)
                                            ->get();
            $approver_ids               = [];
            foreach($company_approvers as $com_approver){
                $approver_ids[]         = $com_approver->user_id;
            }
            $verifiers                  = User::whereIn('id', $verifier_ids)->get();
            $approvers                  = User::whereIn('id', $approver_ids)->get();
        }
        return view('orders.edit', compact('products','verifiers','approvers','order','company'));
    }
    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    
    public function placeOrder(Request $request){

        $order_details                              = Session::get('order_details');
        $user_company                               = DB::table('company_users')
                                                        ->where('user_id',Auth::user()->id)->first();
        $company                                    = Company::find($user_company->company_id);
        if($company->id == 1){
            if(Session::has('company')){
                $company                            = Company::find(Session::get('company'));
            }
        }
        $product_ids                            = $request->input('product_id');
        $product_labels                         = $request->input('label_count');
        if(sizeof($product_ids) > 0){
            $temp_mail_data                             = [];
            $new_order                                  = new Order;
            $new_order->company_id                      = $company->id;
            $new_order->order_placed                    = Auth::user()->id;
            $new_order->date                            = date('Y-m-d H:i:s');
            $new_order->verifier                        = $request->input('verifier');
            $new_order->signatory                       = $request->input('approver');
            $new_order->order_note                      = $request->input('order_note');
            if($new_order->save()){
                $product_ids                            = $request->input('product_id');
                $product_labels                         = $request->input('label_count');
                foreach($product_ids as $t_key => $p_id){
                    $product                            = Product::find($p_id);
                    if($product){
                        $temp_label_count                   = 100;
                        if($product_labels[$t_key]){
                            $temp_label_count           = $product_labels[$t_key];
                        }
                        $order_product_dtls                 = new OrderProductDetil;
                        $order_product_dtls->order_id       = $new_order->id;
                        $order_product_dtls->product_id     = $p_id;
                        $order_product_dtls->label_count    = $temp_label_count;
                        $order_product_dtls->status         = 1;
                        $order_product_dtls->save();
                        $temp_mail_data[]                   = [
                                                                    'product'       => $product, 
                                                                    'label_count'   => $order_product_dtls->label_count
                                                                ];
                    }
                }
            }
            if($new_order){
                $verifier                               = User::find($new_order->verifier );
                $approver                               = User::find($new_order->signatory );

                $orderMail = new OrderNotification($new_order->id, Auth::user()->name ,Auth::user()->name, $verifier->name, $approver->name, 'New Order Created #'.$new_order->id, $new_order); 
                Mail::to(Auth::user()->email)->send($orderMail);

                $orderMail = new OrderNotification($new_order->id, $verifier->name ,Auth::user()->name, $verifier->name, $approver->name, 'New Order Created #'.$new_order->id, $new_order );
                Mail::to($verifier->email)->send($orderMail);

                $orderMail = new OrderNotification($new_order->id, $approver->name ,Auth::user()->name, $verifier->name, $approver->name, 'New Order Created #'.$new_order->id , $new_order);
                Mail::to($approver->email)->send($orderMail);                
            }
        }
        return redirect('orders')->with('success', 'Order Created Successfully!');;
    }

    public function update(Request $request, $id)
    {
        if($request->input('order_update_company')){
            $this->validate($request, [
                    'verifier'      => 'required',
                    'approver'      => 'required',
            ]);
        }else{
            $this->validate($request, [
                    'label_count'   => 'required',
                    'product_id'    => 'required',
                    'verifier'      => 'required',
                    'approver'      => 'required',
            ]);
        }
        
            $order                                                  = Order::find($id);
            if($request->input('order_update_company')){
                $order->company_creator                             = Auth::user()->id;
                $order->company_verifier                            = $request->input('verifier');
                $order->company_approver                            = $request->input('approver');
                $order->company_order_note                          = $request->input('order_note');
            }else{
                $order->verifier                                    = $request->input('verifier');
                $order->signatory                                   = $request->input('approver');
                $order->order_note                                  = $request->input('order_note');
            }
                
            if($order->save()){
                if($request->input('product_id') && sizeof($request->input('product_id')) > 0 ){
                    if(sizeof($request->input('product_id'))  == 1){
                        if($request->input('product_id')[0]  == ''){
                            return redirect('orders')->with('fail', 'Error:: No products Choosed!');;
                        }
                    }
                    
                    if(!$request->input('order_update_company')){
                        OrderProductDetil::where('order_id',$order->id)->delete();

                        $product_labels                         = $request->input('label_count');
                        
                        foreach($request->input('product_id') as $p_key => $p_ids){
                            if($p_ids){
                                $order_product_dtls                     = OrderProductDetil::where([
                                                                            'product_id' => $p_ids,
                                                                            'order_id'   => $order->id
                                                                            ])->first();
                                $temp_label_count                   = 100;
                                if($product_labels[$p_key]){
                                    $temp_label_count           = $product_labels[$p_key];
                                }
                                if(!$order_product_dtls){
                                    $order_product_dtls                 = new OrderProductDetil;
                                    $order_product_dtls->product_id     = $request->input('product_id')[$p_key];
                                    $order_product_dtls->order_id       = $order->id;
                                }
                                $order_product_dtls->label_count        = $temp_label_count;
                                $order_product_dtls->status             = 1;
                                $order_product_dtls->save();
                            }
                        }
                    }
                }
            return redirect('orders')->with('success', 'Order Updated Successfully!');;
        }
        return redirect('orders')->with('fail', 'Error:: No products Choosed!');;
    }

    public function verifyOrder(Request $request){
        $order                          = Order::where(['verifier' => Auth::user()->id])
                                            ->whereIn('status', [0,1,2])
                                            ->find($request->input('order_id'));
        if(!$order){
            $order                      = Order::where(['company_verifier' => Auth::user()->id, 'status' => 3,
                                            'company_print_status' => 1, 'print_status' => 1, 
                                            ])->find($request->input('order_id'));
        }
        if($order){            
            if($request->input('reject')){
                $order->verifier_note           = $request->input('verifier_note');
                $order->status                  = 0;
            }elseif($request->input('verify')){
                $order->verifier_note           = $request->input('verifier_note');
                $order->status                  = 2;
            }elseif($request->input('company_verify')){
                $order->company_verifier_note   = $request->input('verifier_note');
                $order->company_print_status    = 2;
            }elseif($request->input('company_reject')){
                $order->company_verifier_note   = $request->input('verifier_note');
                $order->company_print_status    = 0;
            }
            $order->save();
            if($order->print_status == 1){
                $creator                            = User::find($order->company_creator );
                $verifier                           = User::find($order->company_verifier );
                $approver                           = User::find($order->company_approver );
            }else{
                $creator                            = User::find($order->order_placed );
                $verifier                           = User::find($order->verifier );
                $approver                           = User::find($order->signatory );
            }
            $orderMail = new OrderNotification($order->id, $creator->name ,$creator->name, $verifier->name, $approver->name, 'Order Verified #'.$order->id , $order); 
            Mail::to(Auth::user()->email)->send($orderMail);

            $orderMail = new OrderNotification($order->id, $verifier->name ,$creator->name, $verifier->name, $approver->name, 'Order Verified #'.$order->id, $order );
            Mail::to($verifier->email)->send($orderMail);

            $orderMail = new OrderNotification($order->id, $approver->name ,$creator->name, $verifier->name, $approver->name, 'Order Verified #'.$order->id, $order );
            Mail::to($approver->email)->send($orderMail);


            return redirect('orders')->with('success', 'Order Verified  #'.$order->id);
        }
        return redirect('orders')->with('success', 'Order Not Verified');
    }

    public function approveOrderDetails($id){
        $order_temp                 = Order::find($id);
        $orders_query               = Order::query();
                                    $orders_query->with('products');

        $companies                  = DB::table('company_users')
                                        ->where('user_id',Auth::user()->id)->first();
        if($companies)
        {
            $company                = Company::find($companies->company_id);
        }

        $all_company_receivers      = DB::table('model_has_roles')
                                        ->where('role_id',6)->get();
        $all_receivers_ids          = [];
        foreach($all_company_receivers as $temp_receiver){
            $all_receivers_ids[]    = $temp_receiver->model_id;
        }

        $company_receivers          = DB::table('company_users')
                                        ->where('company_id',$company->id)
                                        ->whereIn('user_id',$all_receivers_ids)
                                        ->get();
        $receiver_ids               = [];
        foreach($company_receivers as $com_receiver){
            $receiver_ids[]         = $com_receiver->user_id;
        }

        $receivers                  = User::whereIn('id', $receiver_ids)->get();

        if(Auth::user()->hasRole(5)){
            $orders_query->orWhere(['signatory' => Auth::user()->id, 'company_approver' => Auth::user()->id]);
            $order                  = $orders_query->find($id);
            return view('orders.approve', compact('order','receivers','company'));
        }
        if(!$order  || ($order->creator->id != Auth::user()->id)){
            return redirect('orders')->with('success', 'Data Not Found!');
        }
        $order                      = $orders_query->find($id);
        return view('orders.approve', compact('order','receivers','company'));
    }   

    public function approveOrder(Request $request){

        $validation_array                   = [];
        if($request->input('approve') || $request->input('company_approve')){
            $validation_array['declaration']    = 'required';
        }    
        
        if($request->input('print_type') == '0'){
            $validation_array['receiver']    = 'required';
        }

        $this->validate($request, $validation_array);
        $companies                          = DB::table('company_users')
                                                ->where('user_id',Auth::user()->id)->first();
        if($companies)
        {
            $company                        = Company::find($companies->company_id);
        }
        
        $order                              = Order::where(['signatory' => Auth::user()->id])
                                                ->whereIn('status', [-1,1,2,3])
                                                ->find($request->input('order_id'));
  
        if(!$order){
            $order                          = Order::where(['company_approver' => Auth::user()->id, 
                                                            'print_status' => 1,'status' => 3])
                                                ->whereIn('company_print_status', [-1,1,2,3])
                                                ->find($request->input('order_id'));
        }
        if($order && !$request->input('company_approve')){
            $order->approver_note           = $request->input('approver_note');
            if($request->input('reject')){
                $order->status              = -1;
            }elseif($request->input('approve') || $request->input('approve_order')){
                $order->status              = 3;
                if($request->input('print_type') == 0){
                    $order->print_status    = 0;
                    $order->receiver        = $request->input('receiver');
                }else{
                    $order->print_status    = 1;
                    $order->receiver        = NULL;
                }
            }elseif($request->input('company_approve_order')){
                $order->company_print_status              = 3;
            }elseif($request->input('company_reject')){
                $order->company_print_status              = -1;
            }
            $order->save();

            $creator                            = User::find($order->order_placed );
            $verifier                           = User::find($order->verifier );
            $approver                           = User::find($order->signatory );

            $orderMail = new OrderNotification($order->id, $creator->name ,$creator->name, $verifier->name, $approver->name, 'Order Approved #'.$order->id, $order ); 
            Mail::to(Auth::user()->email)->send($orderMail);

            $orderMail = new OrderNotification($order->id, $verifier->name ,$creator->name, $verifier->name, $approver->name, 'Order Approved #'.$order->id, $order );
            Mail::to($verifier->email)->send($orderMail);

            $orderMail = new OrderNotification($order->id, $approver->name ,$creator->name, $verifier->name, $approver->name, 'Order Approved #'.$order->id, $order );
            Mail::to($approver->email)->send($orderMail);

            return redirect('orders')->with('success', 'Order Approved #'.$order->id);
        }elseif($request->input('company_approve')){


            $order->company_approver_note   = $request->input('approver_note');
            $order->company_print_status    = 3;
            $order->receiver        = $request->input('receiver');
            $order->save();
            if($order->print_status == 1){
                $creator                            = User::find($order->company_creator );
                $verifier                           = User::find($order->company_verifier );
                $approver                           = User::find($order->company_approver );
            }else{
                $creator                            = User::find($order->order_placed );
                $verifier                           = User::find($order->verifier );
                $approver                           = User::find($order->signatory );
            }
            

            $orderMail = new OrderNotification($order->id, $creator->name ,$creator->name, $verifier->name, $approver->name, 'Order Approved #'.$order->id , $order); 
            Mail::to(Auth::user()->email)->send($orderMail);

            $orderMail = new OrderNotification($order->id, $verifier->name ,$creator->name, $verifier->name, $approver->name, 'Order Approved #'.$order->id, $order );
            Mail::to($verifier->email)->send($orderMail);

            $orderMail = new OrderNotification($order->id, $approver->name ,$creator->name, $verifier->name, $approver->name, 'Order Approved #'.$order->id, $order );
            Mail::to($approver->email)->send($orderMail);
            return redirect('orders')->with('success', 'Order Approved #'.$order->id);
        }       
        return redirect('orders')->with('success', 'Order Not Found');;
    }

    public function orderBatch($id){
        $company                                    = DB::table('company_users')->where('user_id',Auth::user()->id)->first();
        $order                                      = Order::with('products')->where('company_id',$company->company_id)->find($id);
        if(!$order && Auth::user()->hasRole(6)){
            //dd($company->company_id);
            if($company->company_id == 1){
                $order                              = Order::with('products')->where(['status' => 3,'company_print_status' => 3, 'print_status' => 1])->find($id);
                if(!$order){
                    $order                          = Order::with('products')->where(['status' => 3,'company_print_status' => 3, 'print_status' => 0])->find($id);
                }
            }
        }
        if(!$order){
            return redirect('orders')->with('success', 'Error Occured.!');
        }
        return view('orders.batch', compact('order', 'company'));
    }

    public function createBatch($id){
        $order_product_details                          = OrderProductDetil::with('batches')->find($id);
        if($order_product_details && (Auth::user()->hasRole(6))){
            $characters                                 = ['0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z'];
            $batch_number_array                         = [];
            $c = count($characters);
            for($i = 0;$i<$c;$i++){
                for($j = 0;$j<$c;$j++){
                    for($k = 0;$k<$c;$k++){
                        $val                            = $characters[$i].$characters[$j].$characters[$k];
                        $batch_number_array[]           = $val;
                    }
                }
            }
            
            $new_batch_number                           = $batch_number_array[array_rand($batch_number_array)];
            $batch_number_check                         = BatchNumber::where([
                                                                'product_id'    => $order_product_details->product_id,
                                                                'batch_number'  => $new_batch_number,
                                                            ])->first();

            while($batch_number_check){
                $new_batch_number                       = $batch_number_array[array_rand($batch_number_array)];
                $batch_number_check                     = BatchNumber::where([
                                                                'product_id'=> $order_product_details->product_id,
                                                                'batch_number'=> $new_batch_number,
                                                            ])->first();
            }
            $batch_number                               = $new_batch_number;
            return view('orders.createbatch', compact('order_product_details','batch_number'));
        }
        return Redirect::back();
    }

    public function saveBatch(Request $request,$id){
        $this->validate($request, [
            'batch_id'                  => 'required|unique:batch_numbers,batch_number',
            'start_no'                  => 'required|numeric',
            'batch_count'               => 'required|max:3',
            'label1_paper_width'        => 'required',
            'label1_paper_height'       => 'required',
            'label2_paper_width'        => 'required',
            'label2_paper_height'       => 'required',
        ]);

        
        if($request->input('label_preview_1')){
            if($request->input('label_preview_1') == "Label 1 Preview"){
                $order_product_details          = OrderProductDetil::find($id);
                
                    if($order_product_details){
                        $product_details                = Product::find($order_product_details->product_id);
                        if(!$product_details){
                            return Redirect::back();
                        }
                        $paper_size                     = $request->input('paper_size');
                        $batch_count                    = 10;
                        $paper_width_preview            = $request->input('label1_paper_width') * 37.795275591;

                        $batch_pdf                      = PDF::loadView('orders.print_preview', compact('product_details','paper_width_preview','batch_count'))->setPaper([0, 0, $request->input('label1_paper_width') * 28.3465 , $request->input('label1_paper_height') * 28.3465], 'landscape');
                        return $batch_pdf->stream('print_preview.pdf');
                    }
                
            }
        }

        if($request->input('label_preview_2')){
            if($request->input('label_preview_2') == "Label 2 Preview"){
                $order_product_details          = OrderProductDetil::find($id);
                if($order_product_details){
                        $product_details                = Product::find($order_product_details->product_id);
                        if(!$product_details){
                            return Redirect::back();
                        }
                        $paper_size                     = $request->input('paper_size');
                        $batch_count                    = 10;
                        $paper_width_preview            = $request->input('label2_paper_width') * 37.795275591;
                        $batch_pdf                      = PDF::loadView('orders.print_preview_2', compact('product_details','paper_width_preview','batch_count'))->setPaper([0, 0, $request->input('label2_paper_width')* 28.3465, $request->input('label2_paper_height')* 28.3465], 'landscape');
                        return $batch_pdf->stream('print_preview.pdf');
                    }
            }
        }

        $order_product_details                          = OrderProductDetil::find($id);        
        if($order_product_details){
            if($order_product_details->batches->isEmpty()){
                $batch_count                            = $request->input('batch_count');
                $temp_start_count                       = $request->input('start_no');
                $balance_labels                         = $order_product_details->label_count;
                $temp_batch_count                       = floor($order_product_details->label_count/$batch_count);
                for($i = 0; $i < $batch_count; $i++){
                    $order_batch                        = new OrderBatch;
                    $order_batch->product_order_id      = $order_product_details->id;
                    $order_batch->status                = 1;
                    if($i == ($batch_count-1)){
                        $order_batch->label_count       = $balance_labels;
                    }else{
                        $order_batch->label_count       = $temp_batch_count;
                        $balance_labels                 -= $temp_batch_count;
                    }
                    $order_batch->batch_id              = $request->input('batch_id');
                    $order_batch->paper1_size           = json_encode([0,0,$request->input('label1_paper_width')* 28.3465, $request->input('label1_paper_height')* 28.3465]);
                    $order_batch->paper2_size           = json_encode([0,0,$request->input('label2_paper_width')* 28.3465, $request->input('label2_paper_height')* 28.3465]);

                    $order_batch->start_number          = $temp_start_count;
                    $order_batch->save();
                    $temp_start_count                   += $temp_batch_count;
                }
                $new_batch_number                       = new BatchNumber();
                $new_batch_number->order_id             = $order_product_details->order_id;
                $new_batch_number->product_id           = $order_product_details->product_id;
                $new_batch_number->batch_number         = $request->input('batch_id');
                $new_batch_number->save();
            }
        }
        return redirect('order/batch_details/'.$id)->with('success', 'Batch(es) Created Successfully');
    }

    public function batchDetails($id)
    {
        $order_product_details          = OrderProductDetil::with('batches')->find($id);
        if($order_product_details && (Auth::user()->hasRole(6))){
            return view('orders.batchdetails', compact('order_product_details'));
        }
        return Redirect::back();
    }

    public function printBatch($id){
        $batch_details                  = OrderBatch::with('productOrderDetails')->find($id);
        $user_company                   = DB::table('company_users')->where('user_id',Auth::user()->id)->first();
        $company                        = Company::find($user_company->company_id);
        if($user_company->company_id != 1 && $user_company->company_id != $batch_details->productOrderDetails->orderDetails->company_id || !Auth::user()->hasRole(6)){
            return Redirect::back();
        }
        $batch_details->label_status_1 = 2;
        $batch_details->save();
        //return view('orders.batchprint', compact('batch_details','company'));
        $paper_size_array               = json_decode($batch_details->paper1_size);
        $batch_paper_width              = 150;
        if(sizeof($paper_size_array) > 2){
            $batch_paper_width                = $paper_size_array[2];
        }
        $batch_pdf                      = PDF::loadView('orders.batchprint', compact('batch_details','company','batch_paper_width'))->setPaper(json_decode($batch_details->paper1_size), 'landscape');
        return $batch_pdf->stream('batchprint.pdf');
    }

    public function printLabel2($id){
        $batch_details                  = OrderBatch::with('productOrderDetails')->find($id);
        $user_company                   = DB::table('company_users')->where('user_id',Auth::user()->id)->first();
        $company                        = Company::find($user_company->company_id);
        if($user_company->company_id != 1 && $user_company->company_id != $batch_details->productOrderDetails->orderDetails->company_id || !Auth::user()->hasRole(6)){
            return Redirect::back();
        }
        $batch_details->label_status_2  = 2;
        $batch_details->save();
        //return view('orders.batchprint', compact('batch_details','company'));
        $paper_size_array               = json_decode($batch_details->paper2_size);
        $batch_paper_width              = 150;
        if(sizeof($paper_size_array) > 2){
            $batch_paper_width                = $paper_size_array[2];
        }

        $batch_pdf = PDF::loadView('orders.batchlabel2', compact('batch_details','company','batch_paper_width'))->setPaper(
            json_decode($batch_details->paper2_size), 'landscape'); 
        return $batch_pdf->stream('batchlabel2.pdf');
    }

    
    public function productLabelPreview($id){
        $order_product_details          = OrderProductDetil::find($id);
        if($order_product_details ){
            return view('orders.labelpreview', compact('order_product_details'));
        }
        return Redirect::back();
    }

    public function productLabelPreview2($id){
        $order_product_details          = OrderProductDetil::find($id);
        if($order_product_details ){
            return view('orders.labelpreview2', compact('order_product_details'));
        }
        return Redirect::back();
    }


    public function labelPrintPreview(Request $request ,$id){
        $this->validate($request, [
            'paper_size'        => 'required',
        ]);

        $order_product_details          = OrderProductDetil::find($id);
        if($request->input('print_preview') == 'Print Preview'){
            if($order_product_details){
                $product_details                = Product::find($order_product_details->product_id);
                if(!$product_details){
                    return Redirect::back();
                }
                $paper_size                     = $request->input('paper_size');
                $batch_count                    = 10;
                $batch_pdf                      = PDF::loadView('orders.print_preview', compact('product_details','paper_size','batch_count'))->setPaper($paper_size, 'landscape');
                return $batch_pdf->stream('print_preview.pdf');
            }
        }
    }

    public function labelPrintPreview2(Request $request ,$id){
        $this->validate($request, [
            'paper_size'        => 'required',
        ]);

        $order_product_details          = OrderProductDetil::find($id);
        if($request->input('print_preview') == 'Print Preview'){
            if($order_product_details){
                $product_details                = Product::find($order_product_details->product_id);
                if(!$product_details){
                    return Redirect::back();
                }
                $paper_size                     = $request->input('paper_size');
                $batch_count                    = 10;
                $batch_pdf                      = PDF::loadView('orders.print_preview_2', compact('product_details','paper_size','batch_count'))->setPaper([0,0,1000,1500], 'landscape');
                return $batch_pdf->stream('print_preview_2.pdf');
            }
        }
    }

    public function pdf() 
    {
        $data = [
            'name'         => 'John Doe',
            'address'      => 'USA',
            'mobileNumber' => '000000000',
            'email'        => 'john.doe@email.com'
        ];
        $pdf = PDF::loadView('resume', $data);
        return $pdf->stream('resume.pdf');
    }
} 
