<?php

namespace App\Http\Controllers;

use App\Models\PushNotification;
use Illuminate\Http\Request;
use App\Models\User;
use App\Models\Company;
use App\Models\ScannedProduct;

class PushNotificationController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $push_notifications = PushNotification::orderBy('created_at', 'desc')->get();
        return view('notification.index', compact('push_notifications'));
    }
    public function bulksend(Request $request){    
        $this->validate($request, [
            'comapny'=> 'required',
            'title'=> 'required',
            'body'=> 'required',
        ]); 
        $comment                    = new PushNotification();
        $comment->title             = $request->input('title');
        $comment->body              = $request->input('body');
        $comment->company_id        = (int)$request->input('comapny');
        $comment->save();        
        $url                        = 'https://fcm.googleapis.com/fcm/send';
        $dataArr                    = array('click_action' => 'FLUTTER_NOTIFICATION_CLICK', 'id' => $comment->id,'status'=>"done");
        $notification               = array('title' =>$request->title, 'body' => $request->body, 'sound' => 'default', 'badge' => '1', 'android_channel_id' => 'get_origin',);

        $app_user_ids               = [];
        if($request->input('comapny') == '0'){
            $app_users              = User::where('user_type', 1)->get();
        }else{
            $sacnned_list             = ScannedProduct::where('company_id', $request->input('comapny'))->get();
            $app_user_ids           = [];
            foreach($sacnned_list as $list){
                if (!in_array($list->user_id, $app_user_ids)){
                    $app_user_ids[]     = $list->user_id;
                }
            }
            $app_users              = User::where('user_type', 1)->whereIn('id',$app_user_ids)->get();
        }

        $registration_ids           = [];
        foreach($app_users as $app_user){
            if($app_user->fcm_token != '')
                $registration_ids[] =  $app_user->fcm_token;
        }

        $arrayToSend                = [
                                        'registration_ids' => $registration_ids,
                                        'notification' => $notification, 'data' => $dataArr, 
                                        'priority'=>'high'];
        $fields                     = json_encode ($arrayToSend);
        $headers                    = array (
                                        'Authorization: key=' . "AAAAQp6uCzc:APA91bFiHDsR0bIg5jhM32ApnRYUJeex7Tj2J7evTYRV7g0aBxP2uB9SyTx0bKX8U5CfyCx-suKd1l804EWH1oqaI4fhHBTUAPtCXjjasMh5R0WJDyyqrukmDC2-jzr9ObP3yxIGU2Ga",
                                        'Content-Type: application/json'
                                        );        
        $ch                         = curl_init ();
                                        curl_setopt ( $ch, CURLOPT_URL, $url );
                                        curl_setopt ( $ch, CURLOPT_POST, true );
                                        curl_setopt ( $ch, CURLOPT_HTTPHEADER, $headers );
                                        curl_setopt ( $ch, CURLOPT_RETURNTRANSFER, true );
                                        curl_setopt ( $ch, CURLOPT_POSTFIELDS, $fields );           
                                        $result = curl_exec ( $ch );                                        
                                        curl_close ( $ch );                                        
        return redirect()->back()->with('success', 'Notification Send successfully');    
    }   

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    
    public function create()
    {
        $all_companies          = Company::get();
        return view('notification.create',compact('all_companies'));
    }
    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\PushNotification  $pushNotification
     * @return \Illuminate\Http\Response
     */
    public function destroy(PushNotification $pushNotification)
    {
        //
    }


    public function notificationList(Request $request)
    {
        try {
            $notify_query               = PushNotification::orderBy('id','DESC')->get();
            
            $notifications                     = collect($notify_query);
            $datatables                 = datatables()->of($notifications)->addColumn('sl_no', function () {
                                                return '';
                                            });
            $datatables                 = $datatables->addColumn('title', function ($notifications) {
                                                return $notifications->title;
                                            });
            $datatables                 = $datatables->addColumn('content', function ($notifications) {
                                                return $notifications->body;
                                            });

            $datatables                 = $datatables->addColumn('date', function ($notifications) {
                                                return date("d-M-Y", strtotime($notifications->created_at));
                                            });
            $datatables             = $datatables->escapeColumns([])->toJson();
            return $datatables;
        }
        catch (\Exception $e) {
            Log::error("Error in CategoriesController categoryList :- " . $e->getMessage());
        } 
    }
}
