<?php
    
namespace App\Http\Controllers;
    
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
// use App\Http\Controllers\Auth\ResetPasswordController;
use App\Models\User;
use App\Models\Company;
use App\Models\CompanyUser;
use Spatie\Permission\Models\Role;
use Spatie\Permission\Traits\HasRoles;
use DB;
use Hash;
use Illuminate\Support\Arr;
use Illuminate\Support\Facades\Log;
use Auth;
use Session;
use App\Mail\UserInvitationMail;
use Illuminate\Support\Facades\Mail;
use App\Models\ResetCodePassword;
// use DateTime;

    
class UserController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    function __construct()
    {
         $this->middleware('permission:user-list|user-create|user-edit|user-delete', ['only' => ['index','store']]);
         $this->middleware('permission:user-create', ['only' => ['create','store']]);
         $this->middleware('permission:user-edit', ['only' => ['edit','update']]);
         $this->middleware('permission:user-delete', ['only' => ['destroy']]);
    }
    
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index(Request $request)
    {
        try {
            $session_company=Session::get('company');
            // Session::put('company_dropdown', $session_company);
            // $dropdown_company=Session::get('company_dropdown');

           
            if($request['company_id']!=null) {
                $company_id=$request['company_id'];
                // $company=null;
            }
            elseif($request['company_id']==null && $session_company==null) {
                    $company_id=1;
                    // $company=null;
                }
            elseif($session_company!=null){
                $company_id=$session_company;
            }
            else {
                $company_id=$request['company_id'];
                // $company=Company::where('id',$company_id)->first();
            }
            
            $company=Company::where('id',$company_id)->first();

            $companies = Company::pluck('company_name','id')->all();
            
            // return gettype($company_id);
            
            // $data = User::where('deleted',0)->orderBy('id','ASC')->get();
            // // return Datatables::of($data)
            // //             ->make(true);
            // // echo "<pre>";
            // // dd($data->toSql());exit;
        
            // return view('users.index',compact('data'));

            $user=Auth::user();
            $company_user=CompanyUser::where('user_id',$user->id)->first();
            $logged_in_company=$company_user->company_id;

            return view('users.index',compact('company','companies','logged_in_company','company_id'));
        }
        catch (\Exception $e) {
            Log::error("Error in UserController index :- " . $e->getMessage());
        } 
    }
    
    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create(Request $request)
    {
        try {
            $session_company=Session::get('company');

            $roles = Role::whereNotIn('id',[1,2,7])->get();

            // if($session_company==1) {
            //     $roles = Role::whereNotIn('id', [1,2])->get(); 
            // }
            // else{
            //     $roles = Role::whereNotIn('id', [1,7])->get(); 
            // }

            // if($request['company_id']==null && $session_company==null) {
            if($request['company_id']==1) {
                $companies = Company::pluck('company_name','id')->all();
                }
            // elseif($session_company!=null){
            //     $companies = Company::where('id',$session_company)->pluck('company_name','id')->all();
            // }
            else {
                $companies = Company::where('id',$request['company_id'])->pluck('company_name','id')->all();
            }

            // $companies = Company::pluck('company_name','id')->all();

            // $selected_company = Company::pluck('company_name','id')->first();

            // $companies = DB::table('company')->selct('company_name')->all();
            // return $companies;
        
            return view('users.create',compact('roles','companies'));
        }
        catch (\Exception $e) {
            Log::error("Error in UserController create :- " . $e->getMessage());
        } 
    }
    
    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        // try {
            $this->validate($request, [
                'name' => 'required',
                'email' => 'required|email|unique:users,email',
                'phone_code' => 'required|integer|digits_between:2,3',
                'phone' => 'required|integer|digits_between:7,10',
                // 'password' => 'required|same:confirm_password',
                // 'roles' => 'required',
                'designation' => 'required',
                // 'companies' => 'required'
            ]);
        
            $input['name']         = $request->input('name');
            $input['email']        = $request->input('email');
            // $input['password']     = $request->input('password');
            $input['phone_code']   = $request->input('phone_code');
            $input['phone']        = $request->input('phone');
            $input['designation']  = $request->input('designation');
            $input['staff_code']   = $request->input('staff_code');

            if($request->hasFile('image')){
                $input_image_name         = time().'_'.$request->image->getClientOriginalName();
                if($request->file('image')->storeAs('public/app/users',$input_image_name)){
                    $input['image']     = $input_image_name;
                }
            }
        
            // $input['password'] = Hash::make($input['password']);

            // return $input;

            $user = User::create($input);

            

            if(Auth::user()->id == 1){
                $company_array = $request->companies;
            }
            else {
                $company_array = CompanyUser::where('user_id', Auth::user()->id)->pluck('company_id')->all();
                // return $company_array;
            }

            // $companies = new Company;
            // foreach($request->companies as $item => $value) {
            //     $company_id = $companies->getCompanyIdByCode($value);
            //     $data[$value]=array(
            //         'company_id'=>$company_id,
            //         'user_id'=>$user->id,
            //     );
            // }

            $company_id = $request->input('companies');

            $data=array(
                'company_id'=>$company_id,
                'user_id'=>$user->id,
            );

            $user->assignRole($request->input('roles')); // assign roles from selection
            if($company_id==1) {
                $user->assignRole(7);                    // 7 - GetORIGIN Staff
            }
            else {
                $user->assignRole(2);                    // 2 - Company Admin (Other companies)
            }

            CompanyUser::insert($data);

            $this->sendInvitation($user->id);
        
            return redirect()->route('users.index',['company_id' => $company_id])
                            ->with('success','User added and invitation link sent to '.$user->email);
        // }
        // catch (\Exception $e) {
        //     Log::error("Error in UserController store :- " . $e->getMessage());
        // } 
    }
    
    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        // try {
            if($id!=1 || Auth::user()->id == 1) {
                $users = new User;
                $user = $users->getUserDetailsByID($id);
                if($user) {
                    $session_company=Session::get('company');
                    $user_company = $user->userCompany->first();

                    if($session_company == 1 || $session_company == $user_company->company_id) {
                        $userRole =DB::table('users')
                                ->join('model_has_roles', 'users.id', '=', 'model_has_roles.model_id')
                                ->where('users.id',$id)
                                ->join('roles', 'model_has_roles.role_id', '=', 'roles.id')
                                ->whereNotIn('roles.id',[1,2,7])
                                // ->select('roles.name as name')
                                // ->get();
                                ->pluck('roles.name as name','roles.name as name');
                        $company = Company::find($user_company->company_id);
                        $company_name = $company->company_name;

                        // $role_list=implode(", ", $userRole);
                        // $role_list=$userRole;
                        $role_list = $userRole->implode(', ');


                        return view('users.profile',compact('user','company_name','userRole','role_list'));
                    }
                    else {
                        abort(403,"USER DOES NOT HAVE THE RIGHT PERMISSIONS.");
                    }
                }
                else {
                    abort(404);
                }
            }
            else {
                abort(403,"USER DOES NOT HAVE THE RIGHT PERMISSIONS.");
            }
        // }
        // catch (\Exception $e) {
        //     Log::error("Error in UserController edit :- " . $e->getMessage());
        // } 
    }
    
    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit( $id)
    {
        // try {
            if($id!=1 || Auth::user()->id == 1) {
                $users = new User;
                $user = $users->getUserDetailsByID($id);
                if($user) {
                    $session_company=Session::get('company');
                    $user_company = $user->userCompany->first();

                    if($session_company == 1 || $session_company == $user_company->company_id) {
                        
                        $roles = Role::whereNotIn('id',[1,2,7])->get();
                        // if($session_company==1) {
                        //     $roles = Role::whereNotIn('id', [1,2])->get(); 
                        // }
                        // else{
                        //     $roles = Role::whereNotIn('id', [1,7])->get(); 
                        // }
                        // $userRole = $user->roles->pluck('name','name')->all();
                        
                        $userRole = $user->roles->pluck('id','id')->all();

                        $company = $user->userCompany->pluck('company_id','company_id');

                        if($session_company==1) {
                            $companies = Company::pluck('company_name','id')->all();
                            }
                        else {
                            $companies = Company::where('id', $session_company)->pluck('company_name','id')->all();
                        }

                        return view('users.edit',compact('user','companies','company','roles','userRole'));
                    }
                    else {
                        abort(403,"USER DOES NOT HAVE THE RIGHT PERMISSIONS.");
                    }
                }
                else {
                    abort(404);
                }
            }
            else {
                abort(403,"USER DOES NOT HAVE THE RIGHT PERMISSIONS.");
            } 

            
            // else    {
                 
            // }
        // }
        // catch (\Exception $e) {
        //     Log::error("Error in UserController edit :- " . $e->getMessage());
        //     // abort(404);
        // } 
    }
    
    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        // try {
            $this->validate($request, [
                'name' => 'required',
                'email' => 'required|email|unique:users,email,'.$id,
                'phone_code' => 'required|integer|digits_between:2,3',
                'phone' => 'required|integer|digits_between:7,10',
                // 'password' => 'same:confirm_password',
                // 'roles' => 'required',
                // 'companies' => 'required'
            ]);
        
            $input['name']         = $request->input('name');
            $input['email']        = $request->input('email');
            // $input['password']     = $request->input('password');
            $input['phone_code']   = $request->input('phone_code');
            $input['phone']        = $request->input('phone');
            $input['designation']  = $request->input('designation');
            $input['staff_code']   = $request->input('staff_code');
            
            if($request->hasFile('image')){
                $input_image_name         = time().'_'.$request->image->getClientOriginalName();
                if($request->file('image')->storeAs('public/app/users',$input_image_name)){
                    $input['image']     = $input_image_name;
                }
            }

            // if(!empty($input['password'])){ 
            //     $input['password'] = Hash::make($input['password']);
            // }else{
            //     $input = Arr::except($input,array('password'));    
            // }
        
            $users = new User;
            $user = $users->getUserDetailsByID($id);
            $user->update($input);
            DB::table('model_has_roles')->where('model_id',$id)->whereNotIn('role_id',[2,7])->delete();
        
            $user->assignRole($request->input('roles')); // assign roles from selection

            $session_company=Session::get('company');

            $company_id = $request->companies;

            if($session_company == 1){
                DB::table('company_users')->where('user_id',$id)->delete();
                
                // $company_array = $request->companies;

                    $data=array(
                    'company_id'=>$company_id,
                    'user_id'=>$user->id,
                );

                CompanyUser::insert($data);
                // if($data[$value]['company_id']==1) {
                if($company_id==1) {
                    DB::table('model_has_roles')->where('model_id',$id)->where('role_id',2)->delete();
                    $user->assignRole(7);                    // 7 - GetORIGIN Staff
                }
                else {
                    DB::table('model_has_roles')->where('model_id',$id)->where('role_id',7)->delete();
                    $user->assignRole(2);                    // 2 - Company Admin (Other companies)
                }
            }
            
            return redirect()->route('users.index',['company_id' => $company_id])
                            ->with('success','User updated successfully');
        // }
        // catch (\Exception $e) {
        //     Log::error("Error in UserController update :- " . $e->getMessage());
        // } 
    }
    
    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */

     public function editProfile()
     {
         try {
             $user = Auth::user();
            return redirect()->route('users.edit', $user->id);
            //  echo "test";
             // return $user->id;
         }
         catch (\Exception $e) {
             Log::error("Error in UserController destroy :- " . $e->getMessage());
         }  
     }
     
    public function destroy($id)
    {
        try {
            // $user=User::find($id);
            // if($user) {
            //     $user->deleted = 1;
            //     $user->save();
            // }

            // return redirect()->route('users.index')
            //                 ->with('success','User deleted successfully');
            $model = User::find( $id );
            $model->delete();

            $companies = DB::table('company_users')->where('user_id',$id)
                                ->select('company_id','user_id')->first();

            return redirect()->route('users.index',['company_id' => $companies->company_id])
                        ->with('success','User deleted successfully');
        }
        catch (\Exception $e) {
            Log::error("Error in UserController destroy :- " . $e->getMessage());
        } 
    }

    public function userList(Request $request)
    {
        try {
            $User = new User;
            if($request['company_id']==null)   {
                $company = 0;
                }
            else {
                $company = $request['company_id'];
            }
            $company_id=$company;
            $result = $User->get_details_user($company_id);
            $data = collect($result);
            $datatables = datatables()->of($data)->addColumn('sl_no', function () {
                return '';
            });

            $datatables = $datatables->addColumn('name', function ($data) {
                $user_name = $data->name;
                $view = '<span  style="display:none;">'.$user_name.'</span><a href="' . route("users.show", $data->id) . '" title="Show" class="De_view">'.$user_name.'</i>';
                return $view;
            });

            // $datatables = $datatables->addColumn('email', function ($data) {
            //     $user_email = $data->email;
            //     return $user_email;
            // });

            // $datatables = $datatables->addColumn('phone', function ($data) {
            //     $user_email = $data->phone;
            //     return $user_phone;
            // });

            // $datatables = $datatables->addColumn('roles', function ($data) {
            //     if(count($data)) {
            //     foreach($data as $key => $user) {
            //     $roles="";
            //     if(!empty($user->getRoleNames())) {
            //         foreach($user->getRoleNames() as $v) {
            //         $roles.="<label class='badge badge-success'>{{".$v."}}</label>";
            //         }
            //     }
            //     return $roles;
            // }
            // }
            // });

            $datatables = $datatables->addColumn('roles', function ($data) {
                // $user = new User;
                $roles="";
                $user=User::find($data->id);
                // $user=$data->id;
                if($user) {
                    if(!empty($user->getRoleNames())) {
                        foreach($user->getRoleNames() as $v) {
                            if($v!="Managing Staff" && $v!="Company Admin") {
                                $roles.="<label class='badge badge-info'> ".strtoupper(substr($v,0,3))." </label>&nbsp;";
                            }
                        }
                    }
                }
                return $roles;
                
            });

            $datatables = $datatables->addColumn('company', function ($data) {
                $message="";
                $companies = DB::table('company_users')->where('user_id',$data->id)
                                ->select('company_id','user_id')->first();

                if($companies!=null)
                {
                    $company=Company::find($companies->company_id);
                    $message.=$company->id;
                    // $message.="<label class='badge badge-warning'> ".$company->company_name." </label>";
                }
                return $message;
            });


            $datatables = $datatables->addColumn('actions', function ($data) {
                $user = Auth()->user();
                $actions='<div class="action-icons">';
                if($user->can('user-edit')){
                    $actions.='<a href="' . route("users.edit", $data->id) . '" title="Edit" ><i class="fas fa-edit"></i></a>';
                    if($data->invitation_token!=null) {
                        // $actions.='<a href="' . route("resend.email", $data->id) . '" title="Resend Mail"><i class="fa-solid fa-envelope"></i></a>';
                        $actions.='<button type="button" class="btn btn-xs btn-flat show_confirm invite-btn" data-bs-toggle="modal" data-bs-target="#inviteModal'. $data->id .'" data-user-id="'. $data->id .'"  title="Resend Mail"><i class="fa-solid fa-envelope"></i></button>';
                        $actions.='<div class="modal fade" id="inviteModal'. $data->id .'" tabindex="-1" aria-labelledby="deleteModalLabel" aria-hidden="true">
                        <div class="modal-dialog">
                        <div class="modal-content">
                        <div class="modal-header">
                            <h5 class="modal-title" id="inviteModalLabel">Invite Confirmation</h5>
                            </div>
                            <div class="modal-body">
                            Are you sure you want to resend invitation mail to '.$data->email.'?
                            </div>
                            <div class="modal-footer">
                            <button type="button" class="btn btn-secondary modal-btn" data-dismiss="modal">Cancel</button>
                            <a href="' . route("resend.email", $data->id) . '" title="Resend Mail">
                                <button type="submit" class="btn btn-info text-right modal-btn">Resend</button>
                            </a>
                            </div>
                        </div>
                        </div>
                        </div>';

                    }
                }
                if($user->can('user-delete')){
                    $actions.='<button type="button" class="btn btn-xs btn-flat show_confirm delete-btn" data-bs-toggle="modal" data-bs-target="#deleteModal'. $data->id .'" data-user-id="'. $data->id .'"  title="Delete"><i class="fa fa-trash-o" aria-hidden="true"> </i></button>';
                
                
                    $actions.='<div class="modal fade" id="deleteModal'. $data->id .'" tabindex="-1" aria-labelledby="deleteModalLabel" aria-hidden="true">
                    <div class="modal-dialog">
                    <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="deleteModalLabel">Delete Confirmation</h5>
                        </div>
                        <div class="modal-body">
                        Are you sure you want to delete this user?
                        </div>
                        <div class="modal-footer">
                        <button type="button" class="btn btn-secondary modal-btn" data-dismiss="modal">Cancel</button>
                        <form method="POST" action="'.route("users.destroy", $data->id).'">
                        <input name="_method" type="hidden" value="DELETE">
                        <input type="hidden" name="_token" value="'.csrf_token().'" />
                            <button type="submit" class="btn btn-danger text-right modal-btn">Delete</button>
                        </form>
                        </div>
                    </div>
                    </div>
                    </div>';
                }
                $actions.='</div>';
                return $actions;

                // $user_role = $data->role_name;
                // return $user_role;
            });

            $datatables = $datatables->escapeColumns([])->toJson();
                return $datatables;
        }
        catch (\Exception $e) {
            Log::error("Error in UserController userList :- " . $e->getMessage());
        } 


    }

    // public function checkEmail() {
    //     // $name = 'John Doe';
    //     // $invitationUrl = 'https://example.com/invitation?token=abcd1234';
    //     // mail::to('abhijith.calpine@gmail.com')->send(new UserInvitationMail($name, $invitationUrl));
    //     $welcomeEmail = new UserInvitationMail();

    //     Mail::to("abhijith.calpine@gmail.com")->send($welcomeEmail);

    //     return response()->json(['message' => 'Welcome email sent!']);

    // }

    public function sendInvitation($user_id) {
        $user = User::find($user_id);
        $company_user=CompanyUser::where('user_id',$user_id)->first();
        $company_id = (int)$company_user->company_id;
        $invitation_token   = $user->createToken('invitation_token',['*'], now()->addDays(1))->plainTextToken;

        $welcomeEmail = new UserInvitationMail($user->id, $user->name, $user->email, $invitation_token);

        Mail::to($user->email)->send($welcomeEmail);                     // for live site
        // Mail::to('abhijith.calpine@gmail.com')->send($welcomeEmail);        // for testing only

        User::where('id', $user->id)->update(['invitation_token' => $invitation_token, 'invitation_send_date'=>date('Y-m-d H:i:s')]);
        return redirect()->route('users.index',['company_id' => $company_id])->with('success','Invitation link sent to '.$user->email); 
       
    }

    public function activateUser($id,$inv_token) {
        $user=User::find($id);

        $validity = 2;      //validity of token in days

        $current_time = date('Y-m-d H:i:s');
       
        if($user->email_verified_at==null || $user->password==null) {
            if($user->invitation_token!=null && $user->invitation_send_date!=null) {
                // $today = date('Y-m-d h:i:s',$current_time); 
                $invited = $user->invitation_send_date;
                // // $start = strtotime($invited);
                // $test = date_create_from_format('Y-m-d H:i:s', $invited);

                // return gettype($today);

                // $days = $today->diffInDays($start);
                // return $days;

                // $start = new DateTime($invited);
                // $today = new DateTime($current_time);
                // $interval = $start->diff($today);

                $days = (strtotime($current_time) - strtotime($invited)) / (60*60*24); 
                $difference = intval($days); 

                if($user->invitation_token==$inv_token && $difference<=$validity) {
                    User::where('id', $user->id)->update(['email_verified_at' =>  date('Y-m-d H:i:s')]);
                    // User::where('id', $user->id)->update(['invitation_token' => null]);
                    return redirect()->route('password.request');
                    // echo "a";
                }
                elseif($user->invitation_token==$inv_token && $difference>$validity) {
                    // User::where('id', $user->id)->update(['invitation_token' => null]);
                    $heading = "Token Expired";
                    $description = "Token provided is expired its validity. Please contact system administrator.";
                    $link = "No";
                    return view('message',compact('heading','description','link'));
                }
                elseif($user->invitation_token!=$inv_token) {
                    $heading = "Invalid Token";
                    $description = "Token provided through link is not valid. Please check the link or contact system administrator.";
                    $link = "No";
                    return view('message',compact('heading','description','link'));
                }
            }
            else {
                $heading = "Something went wrong";
                $description = "Please check the link.";
                $link = "No";
                return view('message',compact('heading','description','link'));
            }
        }
        else {
                $heading = "Already verified";
                $description = 'You have been verified already. You can login using link below ';
                $link = "login";
                return view('message',compact('heading','description','link')); 
        }  
    } 


    public function validateUserMail(Request $request)
    {
        $user_email      = $request->input('user_email');
        $user_id            = $request->input('user_id');
        
        $email_check        = User::where(['email' => $user_email,])->where('id', '!=', $user_id)->withTrashed()->first();
        $response           = [];
        if($email_check){
            $response['status']         = false;
            $response['msg']            = 'The email has already been taken.';
        }else{
            $response['status']         = true;
        }
        echo json_encode($response);
        return;
    }

    public function validateNewUserMail(Request $request)
    {
        $user_email                     = $request->input('user_email');
        $email_check                    = User::where('email', $user_email)->withTrashed()->first();
        $response                       = [];
        if($email_check){
            $response['status']         = false;
            $response['msg']            = 'The email has already been taken.';
        }else{
            $response['status']         = true;
        }
        echo json_encode($response);
        return;
    }

    
    public function validateNewStaffCode(Request $request)
    {
        $staff_code                     = $request->input('staff_code');
        $company_id                     = $request->input('company_id');
        // $staff_code_check               = User::where(['staff_code'=> $staff_code,'company_id'=>$company_id])->withTrashed()->first();
        $staff_code_check               = DB::table('users')
                                            ->join('company_users', 'users.id', '=', 'company_users.user_id')
                                            ->where(['users.staff_code' => $staff_code, 'company_users.company_id'=>$company_id])
                                            ->where('users.staff_code','!=',null)
                                            ->select('users.id as id','users.name as name','users.staff_code as staff_code')->first();                      
        $response                       = [];
        if($staff_code_check){
            $response['status']         = false;
            $response['msg']            = 'The staff code has already been taken for this company.';
        }else{
            $response['status']         = true;
        }
        echo json_encode($response);
        return;
    }

    public function validateStaffCode(Request $request)
    {
        $staff_code                     = $request->input('staff_code');
        $company_id                     = $request->input('company_id');
        $user_id                        = $request->input('user_id');

        // $staff_code_check               = User::where(['staff_code'=> $staff_code,'company_id'=>$company_id])->withTrashed()->first();
        $staff_code_check               = DB::table('users')
                                            ->join('company_users', 'users.id', '=', 'company_users.user_id')
                                            ->where(['users.staff_code' => $staff_code, 'company_users.company_id'=>$company_id])
                                            ->where('users.staff_code','!=',null)
                                            ->where('users.id','!=',$user_id)
                                            ->select('users.id as id','users.name as name','users.staff_code as staff_code')->first();                      
        $response                       = [];
        if($staff_code_check){
            $response['status']         = false;
            $response['msg']            = 'The staff code has already been taken for this company.';
        }else{
            $response['status']         = true;
        }
        echo json_encode($response);
        return;
    }



    public function appUsers(Request $request)
    {
        try {
            return view('users.app_users');
        }
        catch (\Exception $e) {
            Log::error("Error in UserController index :- " . $e->getMessage());
        } 
    }

    public function fetchAppUsers(Request $request)
    {
        try {
            $result                     = User::where(['user_type' => 1])->get();
            $data                       = collect($result);
            $datatables                 = datatables()->of($data)->addColumn('sl_no', function () {
                                                return '';
                                            });

            $datatables                 = $datatables->addColumn('name', function ($data) {
                                            $user_name = $data->name;
                                            $view = '<span  style="display:none;">'.$user_name.'</span><a href="' . url("app-user-details/".$data->id) . '" title="Show" class="De_view">'.$user_name.'</i>';
                                            return $view;
            });
            /*
            $datatables = $datatables->addColumn('actions', function ($data) {
                $user = Auth()->user();
                $actions='<div class="action-icons">';
                if($user->can('user-edit')){
                    $actions.='<a href="' . route("users.edit", $data->id) . '" title="Edit" ><i class="fas fa-edit"></i></a>';
                }
                $actions.='</div>';
                return $actions;

                // $user_role = $data->role_name;
                // return $user_role;
            });
            */
            $datatables = $datatables->escapeColumns([])->toJson();
                return $datatables;
        }
        catch (\Exception $e) {
            Log::error("Error in UserController userList :- " . $e->getMessage());
        } 


    }

    public function appUserDetails($app_user){
            if($app_user!=1 || Auth::user()->id == 1) {
                $user           = User::find($app_user);
                if($user) {
                    return view('users.app-user-profile', compact('user'));
                }
                else {
                    abort(404);
                }
            }
            else {
                abort(403,"USER DOES NOT HAVE THE RIGHT PERMISSIONS.");
            }
        // }
        // catch (\Exception $e) {
        //     Log::error("Error in UserController edit :- " . $e->getMessage());
        // } 
    }

    public function appUserPasswordResetForm(Request $request){
        $user_email             = $request->input('email');
        $reset_token            = $request->input('token');

        $password_request       = ResetCodePassword::where(['email'=> $user_email, 'token' => $reset_token ])->orderBy('id', 'desc')->first();
        //dd($user_email); 
        if($password_request){
            return view('auth.appResetPassword', ['token' => $reset_token]);
        }
        

    }

    public function submitResetPassword(Request $request) {

          $request->validate([
              'email' => 'required|email|exists:users',
              'password' => 'required|string|min:6|confirmed',
              'password_confirmation' => 'required'
          ]);
          $updatePassword = ResetCodePassword::where([
                                'email' => $request->email, 
                                'token' => $request->token
                              ])->first();
          if(!$updatePassword){
              return back()->withInput()->with('error', 'Invalid token!');
          }
          $user = User::where(['email' => $request->email, 'user_type' => 1])->update(['password' => Hash::make($request->password)]);

          DB::table('password_resets')->where(['email'=> $request->email])->delete();
          return redirect('/login')->with('message', 'Your password has been changed!');
      }
}

