<?php

namespace App\Http\Middleware;

use Closure;
use Illuminate\Http\Request;
use Symfony\Component\HttpFoundation\Response;

use App\Models\CompanyUser;
use App\Models\Company;
use App\Models\User;
use App\Models\Order;
use App\Models\OrderBatch;
use App\Models\OrderProductDetil;
use App\Models\Product;
use Auth;
use Session;
use View;

class SideContent
{
    /**
     * Get the path the user should be redirected to when they are not authenticated.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return string|null
     */
    public function handle(Request $request, Closure $next, ...$guards)
    {
        $user                                         =  Auth::user();
        if($user){
            $company_user                                 = CompanyUser::where('user_id',$user->id)->first();
            
            if(Session::get('company')){
              $company_id                                 = Session::get('company');   
              $company                                    = Company::where('id',$company_id)->first();  
            }else {
                $company                                  = Company::where('id',$company_user->company_id)->first();
            }
            $side_content_data                               = [];
            $side_content_data['company']                   = $company;
            if($company->id == 1){
              $side_content_data['total_companies']          = Company::get()->count();
              $side_content_data['app_users_count']          = User::where('user_type' , 1)->get()->count();  
              $side_content_data['order_count']              = Order::where('print_status',1)->get()->count();  



              $side_content_data['total_labels']             = OrderBatch::get();
              $side_content_data['total_printed_labels']     = OrderBatch::where('label_status_1' , 2)->get();
              $side_content_data['total_un_printed_labels']  = OrderBatch::where('label_status_1' , 1)->get();

              $side_content_data['latest_orders']            = Order::where('print_status',1)->limit(5)->orderBy('id','desc')->get();
              $side_content_data['latest_products']          = Product::limit(5)->orderBy('id','desc')->get();
            }else{
                //dd($company_id );
                $side_content_data['total_companies']          = Company::get()->count();
                $side_content_data['app_users_count']          = User::where('user_type' , 1)->get()->count();  
                $side_content_data['order_count']              = Order::where(['print_status' => 1 , 'company_id' => $company_id])->get()->count();  

                $side_content_data['total_labels']             = 0;
                $side_content_data['total_printed_labels']     = 0;
                $side_content_data['total_un_printed_labels']  = 0;

                $order_list                                 = Order::where('company_id', $company_id)->get();

                foreach($order_list as $order){
                  $order_details                            = OrderProductDetil::where('order_id',$order->id)->get();

                  foreach($order_details as $order_detail){
                    if( $order_detail->batches->isNotEmpty()){
                        foreach($order_detail->batches as $batches){
                          $side_content_data['total_labels']   += $batches->label_count;
                          if($batches->label_status_1 == 2){
                            $side_content_data['total_printed_labels'] += $batches->label_count;
                          }

                          if($batches->label_status_1 == 1){
                            $side_content_data['total_un_printed_labels'] += $batches->label_count;
                          }
                        }
                    }
                  }
                }
                
                $side_content_data['latest_orders']              = Order::where('company_id',$company_id)->limit(5)->orderBy('id','desc')->get();
                $side_content_data['latest_products']              = Product::where('company_id',$company_id)->limit(5)->orderBy('id','desc')->get();
            }

            View::share('side_content_data', $side_content_data);
        }
        return $next($request);
    }
}
