<?php

namespace App\Mail;

use Illuminate\Bus\Queueable;
use Illuminate\Contracts\Queue\ShouldQueue;
use Illuminate\Mail\Mailable;
use Illuminate\Queue\SerializesModels;

class OrderNotification extends Mailable
{
    use Queueable, SerializesModels;

    public $order_id;
    public $user;
    public $creator;
    public $verifier;
    public $approver;
    public $messages;
    public $orderDetails;
    public function __construct($order_id,$user, $creator, $verifier, $approver, $messages = '',$orderDetails)
    {
        $this->order_id     = $order_id;
        $this->user         = $user;
        $this->creator      = $creator;
        $this->verifier     = $verifier;
        $this->approver     = $approver;
        $this->messages     = $messages;
        $this->orderDetails = $orderDetails;
    }

    public function build()
    {
        return $this->view('notifications.order')
                    ->with([
                        'order_id'      => $this->order_id,
                        'user'          => $this->user,
                        'creator'       => $this->creator,
                        'verifier'      => $this->verifier,
                        'approver'      => $this->approver,
                        'messages'      => $this->messages,
                        'orderDetails'  => $this->orderDetails,
                    ])
                    ->subject('Order Details #'.$this->order_id);
    }
}