<?php

namespace App\Mail;

use Illuminate\Bus\Queueable;
use Illuminate\Contracts\Queue\ShouldQueue;
use Illuminate\Mail\Mailable;
use Illuminate\Queue\SerializesModels;

class UserInvitationMail extends Mailable
{
    use Queueable, SerializesModels;

    public $id;
    public $name;
    public $email;
    public $token;



    public function __construct($id,$name,$email,$token)
    {
        $this->id    = $id;
        $this->name  = $name;
        $this->email = $email;
        $this->token = $token;
        $this->base_url  = url('/');
    }

    public function build()
    {
        return $this->view('invitation.user')
                    ->with([
                        'id' => $this->id,
                        'name' => $this->name,
                        'email' => $this->email,
                        'path' => $this->base_url.'/activate/'.$this->id.'/'.$this->token,
                    ])
                    ->subject('Activate Your GetOrigin Account Now');
    }
}