<?php

namespace App\Mail;

use Illuminate\Bus\Queueable;
use Illuminate\Contracts\Queue\ShouldQueue;
use Illuminate\Mail\Mailable;
use Illuminate\Queue\SerializesModels;

class UserResetPasswordMail extends Mailable
{
    use Queueable, SerializesModels;

    public $id;
    public $name;
    public $email;
    public $token;



    public function __construct($id,$name,$email,$token)
    {
        $this->id           = $id;
        $this->name         = $name;
        $this->email        = $email;
        $this->token        = $token;
        $this->base_url     = url('/');
    }

    public function build()
    {
        return $this->view('password.reset')
                    ->with([
                        'id'        => $this->id,
                        'name'      => $this->name,
                        'email'     => $this->email,
                        'path'      => $this->base_url.'/'.$this->token,
                    ])
                    ->subject('Reset Password GetOrigin');
    }
}