<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;

class Chat extends Model
{
    use HasFactory,SoftDeletes;

    public function product()
    {
        return $this->hasOne(Product::class,'id','product_id');
    }

    public function company()
    {
        return $this->hasOne(Company::class,'id','company_id');
    }


    public function messages()
    {
        return $this->hasMany(ChatMessage::class,'chat_id','id')->orderBy('id','desc');;
    }

    public function unreadedMessages()
    {
        return $this->hasMany(ChatMessage::class,'chat_id','id')->where('type', 1)->where('status', 1)->orderBy('id','desc');;
    }

    public function unreadedMessagesAppUser()
    {
        return $this->hasMany(ChatMessage::class,'chat_id','id')->where('type', 0)->where('status', 1)->orderBy('id','desc');;
    }

    public function lastMessage()
    {
        return $this->hasMany(ChatMessage::class,'chat_id','id')->orderBy('id','desc')->limit(1);
    }

    public function from()
    {
        return $this->hasOne(User::class,'id','creator');
    }

    public function to()
    {
        return $this->hasOne(User::class,'id','receiver');
    }

    
}
