<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;

class Order extends Model
{
    use HasFactory,SoftDeletes;


    public function products()
    {
        return $this->hasMany(OrderProductDetil::class,'order_id','id');
    }

    public function creator()
    {
        return $this->hasOne(User::class,'id','order_placed');
    }

    public function userVerifier()
    {
        return $this->hasOne(User::class,'id','verifier');
    }

    public function approver()
    {
        return $this->hasOne(User::class,'id','signatory');
    }

    public function companyCreator()
    {
        return $this->hasOne(User::class,'id','company_creator');
    }

    public function companyVerifier()
    {
        return $this->hasOne(User::class,'id','company_verifier');
    }

    public function companyApprover()
    {
        return $this->hasOne(User::class,'id','company_approver');
    }

    public function company()
    {
        return $this->hasOne(Company::class,'id','company_id');
    }
}
