<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;

class OrderBatch extends Model
{
    use HasFactory,SoftDeletes;

    public function productOrderDetails()
    {
        return $this->hasOne(OrderProductDetil::class,'id','product_order_id');
    }

    public function getReports($start_date="", $end_date="") {
        try {

            $batches = OrderBatch::orderBy('id', 'DESC');
            if($start_date!="") {
                $batches = $batches->where('created_at','>=',$start_date);
            }
            if($end_date!="") {
                $batches = $batches->where('created_at','<=',$end_date);
            }
           return $batches->get();
        } catch (\Exception $e) {
            Log::error("SQL error in OrderBatch getReports :- " . $e->getMessage());
        }
    }
}
