<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;
use DB;
use Log;
class Product extends Model
{
    use HasFactory,SoftDeletes;


    public function company()
    {
        return $this->hasOne(Company::class,'id','company_id');
    }

    public function category()
    {
        return $this->hasOne(Categories::class,'id','category_id');
    }
    
    public function partWarranty()
    {
        return $this->hasMany(WarrantyPart::class,'product_id','id');
    }

    public function productWarranty()
    {
        return $this->hasOne(ProductWarranty::class,'product_id','id');
    }

    public function productOrders()
    {
        return $this->hasMany(OrderProductDetil::class,'product_id','id');
    }

    public function get_details_product($company_id) {
        try {
            
            $product= Product::where('company_id',$company_id)->get();
            return $product;

        } catch (\Exception $e) {
            Log::error("SQL error in Users get_details_users :- " . $e->getMessage());
        }
    }

    public function getReports($company_id = '', $category_id="",$status="",$start_date="", $end_date="") {
        try {
            $product = Product::select('id', 'product_name', 'product_code', 'model_number','brand_name', 'description', 'product_image','created_at')->with('productWarranty')
                    ->orderBy('id', 'DESC');
            if($company_id!="") {
                $product = $product->where('company_id',$company_id);
            }

            if($category_id!="") {
                $product = $product->where('category_id',$category_id);
            }

            if($status!="") {
                $product = $product->where('status',$status);
            }

            if($start_date!="") {
                $product = $product->where('created_at','>=',$start_date);
            }
            if($end_date!="") {
                $product = $product->where('created_at','<=',$end_date);
            }

           return $product->get();
        } catch (\Exception $e) {
            Log::error("SQL error in Company getDetailsCompany :- " . $e->getMessage());
        }
    }

}
