<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Auth;
class ScannedProduct  extends Model
{
    use HasFactory;

    
    public function product()
    {
        return $this->hasOne(Product::class,'id','product_id');
    }

    public function user()
    {
        return $this->hasOne(User::class,'id','user_id');
    }

    public function company()
    {
        return $this->hasOne(Company::class,'id','company_id');
    }
    
    public function chat()
    {
        return $this->hasOne(Chat::class,'code','code')->where('creator', Auth::user()->id);
    }

    public function warranty()
    {
        return $this->hasOne(AppProductWarranty::class,'scan_id','code');
    }

    public function getReports($start_date="", $end_date="") {
        try {

            $scanned_product = ScannedProduct::with('product','user','company')->orderBy('id', 'DESC');
            if($start_date!="") {
                $scanned_product = $scanned_product->where('created_at','>=',$start_date);
            }
            if($end_date!="") {
                $scanned_product = $scanned_product->where('created_at','<=',$end_date);
            }
           return $scanned_product->get();
        } catch (\Exception $e) {
            Log::error("SQL error in OrderBatch getReports :- " . $e->getMessage());
        }
    }
}
