<?php
  
namespace App\Models;
  
use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;
use Laravel\Sanctum\HasApiTokens;
use Spatie\Permission\Traits\HasRoles;
use DB;
use Str;
use Laravel\Sanctum\NewAccessToken;
use Illuminate\Support\Facades\Log;
use Illuminate\Database\Eloquent\SoftDeletes;
use Auth;
  
class User extends Authenticatable
{
    use HasApiTokens, HasFactory, Notifiable, HasRoles, SoftDeletes;
  
    /**
     * The attributes that are mass assignable.
     *
     * @var array

     */
    protected $fillable = [
        'name',
        'email',
        'password',
        'phone_code',
        'phone',
        'designation',
        'image',
        'invation_token',
        'invitation_send_date',
        'staff_code'
    ];

    /**
     * The attributes that should be hidden for serialization.
     *
     * @var array
     */
    protected $hidden = [
        'password',
        'remember_token',
    ];

    /**
     * The attributes that should be cast.
     *
     * @var array<string, string>
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];

    /*
    public function createToken(string $name, $abilities = ['*'])
    {
        $token = $this->tokens()->create([
            'name' => $name,
            'token' => hash('sha256', $plainTextToken = Str::random(40)),
            'abilities' => $abilities,
            'expires_at' => now()->addDays(1)  
        ]); 
        return new NewAccessToken($token, $token->getKey().'|'.$plainTextToken);
    }
    
    */
    public function getUserDetailsByID($id) {
        $user = User::where('id',$id)->where('deleted_at',null)->first();
        return $user;
    }

    public function get_details_user($company_id) {
        try {
            $user                   = Auth::user();
            $company_user           = CompanyUser::where('user_id',$user->id)->first();
            $logged_in_company      = $company_user->company_id;

            if($logged_in_company == 1){
            // if(Auth::user()->id == 1){
                // if($company_id==0) {
                // $user = User::where('id','!=','1')
                //                 ->select('id','name','email','phone')
                //                 ->orderBy('id', 'DESC')
                //                 ->distinct('users.id');
                // }
                if($company_id==0) {
                    $user = DB::table('users')
                        ->join('model_has_roles', 'users.id', '=', 'model_has_roles.model_id')
                        ->where('users.id','!=','1')
                        ->where('users.deleted_at','=',null)
                        // ->where('model_has_roles.roles_id','!=',null)
                        ->select('users.id as id','users.name as name','users.email as email','users.phone as phone', 'users.designation as designation','users.invitation_token as invitation_token')
                        ->orderBy('users.id', 'DESC')
                        ->distinct('users.id');;
                }  
                
                else{
                    $user = DB::table('users')
                                ->join('company_users', 'users.id', '=', 'company_users.user_id')
                                ->where('users.id','!=','1')
                                ->where('users.deleted_at','=',null)
                                ->where('company_users.company_id','=',$company_id)
                                ->select('users.id as id','users.name as name','users.email as email','users.phone as phone', 'users.designation as designation','users.invitation_token as invitation_token')
                                ->orderBy('users.id', 'DESC');
                }
            }
            else {
                $company = DB::table('company_users')->where('user_id',Auth::user()->id)->first();
                // print_r($company);
                $user = DB::table('users')
                                ->join('company_users', 'users.id', '=', 'company_users.user_id')
                                ->where('users.id','!=','1')
                                ->where('users.deleted_at','=',null)
                                ->where('company_users.company_id','=',$company->company_id)
                                ->select('users.id as id','users.name as name','users.email as email','users.phone as phone', 'users.designation as designation','users.invitation_token as invitation_token')
                                ->orderBy('users.id', 'DESC');
                                // ->distinct('users.id');
                // print_r($company);
                // DB::enableQueryLog();
                // $user->get();
                // $query = DB::getQueryLog();
                // dd($query);
            }


           return $user->get();
        } catch (\Exception $e) {
            Log::error("SQL error in Users get_details_users :- " . $e->getMessage());
        }
    }

    public function get_details_app_user($company_id) {
        try {
            $user=Auth::user();
            $company_user=CompanyUser::where('user_id',$user->id)->first();
            $logged_in_company=$company_user->company_id;
            if($logged_in_company == 1){
            
                if($company_id==0) {
                    $user = DB::table('users')
                        ->leftJoin('model_has_roles', 'users.id', '=', 'model_has_roles.model_id')
                        ->where('users.id','!=','1')
                        // ->where('model_has_roles.roles_id','!=',null)
                        ->select('users.id as id','users.name as name','users.email as email','users.phone as phone')
                        ->orderBy('users.id', 'DESC')
                        ->distinct('users.id');;
                }  
                
                else{
                    $user = DB::table('users')
                                ->join('company_users', 'users.id', '=', 'company_users.user_id')
                                ->where('users.id','!=','1')
                                ->where('company_users.company_id','=',$company_id)
                                ->select('users.id as id','users.name as name','users.email as email','users.phone as phone')
                                ->orderBy('users.id', 'DESC');
                }
            }
            else {
                $company = DB::table('company_users')->where('user_id',Auth::user()->id)->first();
                // print_r($company);
                $user = DB::table('users')
                                ->join('company_users', 'users.id', '=', 'company_users.user_id')
                                ->where('users.id','!=','1')
                                ->where('company_users.company_id','=',$company->company_id)
                                ->select('users.id as id','users.name as name','users.email as email','users.phone as phone')
                                ->orderBy('users.id', 'DESC');
               
            }


           return $user->get();
        } catch (\Exception $e) {
            Log::error("SQL error in Users get_details_users :- " . $e->getMessage());
        }
    }

    public function userCompany() {
        return $this->hasMany(CompanyUser::class);
    } 
}
