<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

return new class extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('company', function (Blueprint $table) {
            $table->id();
            $table->string('company_name');
            $table->string('company_code')->unique();
            $table->string('building_name');
            $table->string('area')->nullable();
            $table->string('landmark')->nullable();
            $table->string('town')->nullable();
            $table->integer('pin')->nullable();
            $table->string('state')->nullable();
            $table->string('country')->nullable();
            $table->string('email');
            $table->string('telephone');
            $table->string('website')->nullable();
            $table->string('note')->nullable();
            $table->softDeletes();
            $table->timestamps();
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('company');
    }
};
