    <?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

return new class extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        /**/
        Schema::create('products', function (Blueprint $table) {
            $table->id();
            $table->string('product_name');
            $table->string('brand_name')->nullable();
            $table->string('product_code')->unique();
            $table->text('description')->nullable();
            $table->date('warranty_month')->nullable();
            $table->text('product_image')->nullable();
            $table->text('product_logo')->nullable();
            $table->text('product_label')->nullable();

            $table->integer('quantity')->nullable();
            $table->string('quantity_measured')->nullable();
            $table->integer('number_in_pack')->nullable();
            $table->string('packing_method')->nullable();
            $table->integer('expiry_period')->nullable();
            $table->text('purchase_link')->nullable();

            $table->text('url')->nullable();            
            $table->integer('qrcode_size')->nullable();
            $table->integer('qrcode_top')->nullable();
            $table->integer('qrcode_left')->nullable();
            $table->integer('company_id');
            $table->integer('category_id');            
            $table->integer('status')->default('1');

            $table->decimal('qrcode_ratio', 10, 5)->default('1.0');;
            $table->decimal('qrcode_ratio2', 10, 5)->default('1.0');;
            
            
            $table->timestamps();
            $table->softDeletes($column = 'deleted_at');
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('products');
    }
};
