<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

return new class extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('orders', function (Blueprint $table) {
            $table->id();            
            $table->integer('company_id');
            $table->integer('order_placed');
            $table->timestamp('date');
            $table->integer('status')->default('1');
            $table->integer('print_status')->default('1');
            $table->integer('company_print_status')->default('1');
            $table->integer('verifier')->nullable();
            $table->integer('signatory')->nullable();
            $table->integer('receiver')->nullable();
            $table->text('order_note')->nullable();
            $table->text('verifier_note')->nullable();
            $table->text('approver_note')->nullable();
            $table->text('company_order_note')->nullable();
            $table->text('company_verifier_note')->nullable();
            $table->text('company_approver_note')->nullable();
            
            $table->integer('company_creator')->nullable();
            $table->integer('company_verifier')->nullable();
            $table->integer('company_approver')->nullable();
            $table->integer('comany_receiver')->nullable();
            $table->timestamps();
            $table->softDeletes($column = 'deleted_at');
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('orders');
    }
};
