<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

return new class extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('product_warranty', function (Blueprint $table) {
            $table->id();
            $table->unsignedBigInteger('product_id');
            $table->foreign('product_id')->references('id')->on('products');
            $table->string('waranty_status');
            $table->string('service_status')->nullable();
            $table->string('full_product')->nullable();
            $table->integer('s_warranty_count')->nullable();
            $table->string('s_warranty_duration')->nullable();
            $table->string('replacement_status')->nullable();
            $table->integer('r_warranty_count')->nullable();
            $table->string('r_warranty_duration')->nullable();
            $table->string('promotion_status')->nullable();

        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('product_warranty');
    }
};
