<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

return new class extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('app_product_warranties', function (Blueprint $table) {
            $table->id();
            $table->string('scan_id')->nullable();
            $table->unsignedBigInteger('user_id');            
            $table->integer('product_id')->nullable();
            $table->string('product_name')->nullable();
            $table->string('product_brand')->nullable();
            $table->string('product_image')->nullable();
            $table->integer('type')->nullable()->default('0')->comment('0=>service_warranty, 1 =>replacement ');
            $table->integer('product_warranty')->nullable()->default('0')->comment('0 => whole product warranty, 1 => Part warranty ');
            $table->string('waranty_period');
            $table->string('purchase_point_name')->nullable();
            $table->string('purchase_point_phone')->nullable();
            $table->string('service_center_name')->nullable();
            $table->string('service_center_phone')->nullable();
            $table->timestamp('invoice_date')->nullable();
            $table->string('invoice_file')->nullable();
            $table->string('service_invoice_file')->nullable();
            $table->text('note')->nullable();  
            $table->integer('registration_type')->nullable()->default('0')->comment('0 => scanned_product , 1 => without QR code');  
            $table->timestamps();
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('app_product_warranties');
    }
};
