<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

return new class extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('chats', function (Blueprint $table) {
            $table->id();
            $table->integer('creator');
            $table->integer('receiver');
            $table->integer('product_id');
            $table->integer('company_id')->default(1);
            $table->string('code')->nullable();
            $table->timestamp('date');
            $table->string('title')->default(0); 
            $table->integer('status')->default(1);    
            $table->integer('chat_type')->default(1);
            $table->integer('chat_on')->comment('0=>seller\r\n1 =>product')->default(1);
            $table->timestamps();
            $table->softDeletes($column = 'deleted_at');
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('chats');
    }
};
