<?php

namespace Database\Seeders;

use Illuminate\Database\Console\Seeds\WithoutModelEvents;
use Illuminate\Database\Seeder;
use Spatie\Permission\Models\Role;

class RolesTableSeeder extends Seeder
{
    /**
     * Run the database seeds.
     *
     * @return void
     */
    public function run()
    {

        $role = Role::create(['name' => 'Company Admin'])
            ->givePermissionTo(['user-list',
                'user-create',
                'user-edit',
                'user-delete',
                'products-list',
                'products-create',
                'products-edit',
                'products-delete'
            ]);
        $role = Role::create(['name' => 'Creator'])
            ->givePermissionTo(['orders-list',
            'orders-create',
            'orders-edit',
            'orders-delete']);
        $role = Role::create(['name' => 'Verifier'])
            ->givePermissionTo(['orders-list']);
        $role = Role::create(['name' => 'Signatory'])
            ->givePermissionTo(['orders-list']);
        $role = Role::create(['name' => 'Receiver'])
            ->givePermissionTo(['orders-list']);
        $role = Role::create(['name' => 'Managing Staff'])
            ->givePermissionTo(['user-list',
                'user-create',
                'user-edit',
                'user-delete',
                'products-list',
                'products-create',
                'products-edit',
                'products-delete',
                'category-list',
                'category-create',
                'category-edit',
                'category-delete',
                'company-list',
                'company-create',
                'company-edit',
                'company-delete',
            ]);
    }
}
