
<?php
  
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Route;
  
use App\Http\Controllers\API\RegisterController;
use App\Http\Controllers\API\ProductController;
use App\Http\Controllers\API\APITestController;

/*
|--------------------------------------------------------------------------
| API Routes
|--------------------------------------------------------------------------
|
| Here is where you can register API routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| is assigned the "api" middleware group. Enjoy building your API!
|
*/
Route::get('invalid_session', function(){
    return response()->json([
            'status'        => false,
            'message'       => 'Session Expired! Please Re-Login.'
        ]);
})->name('invalid_session');

Route::get('/product/{batch_no?}', [App\Http\Controllers\API\APITestController::class, 'product']);

Route::get('/product/{batch_no?}', [App\Http\Controllers\API\APITestController::class, 'product']);
Route::get('/product-details/{product_code?}', [App\Http\Controllers\API\MobileappController::class, 'details']);

Route::controller(RegisterController::class)->group(function(){
    Route::post('/register', 'register');
    Route::post('/login', 'login');
});


//Route::get('/user_details', [App\Http\Controllers\API\APITestController::class, 'user'])->name('user'); 
//Route::middleware('auth:sanctum')->group( function () {

Route::any('/reset_user_password', [App\Http\Controllers\API\RegisterController::class, 'resetPassword'])->name('resetPassword');
Route::any('/reset_app_password', [App\Http\Controllers\API\RegisterController::class, 'resetAppPassword'])->name('resetAppPassword');

Route::group(['middleware' => ['auth:sanctum']], function() {
    Route::post('/user_auth_check', [App\Http\Controllers\API\RegisterController::class, 'userAuthCheck'])->name('userAuthCheck');
       

    
    Route::get('/user_details', [App\Http\Controllers\API\RegisterController::class, 'user'])->name('user');
    Route::any('/product_details', [App\Http\Controllers\API\MobileappController::class, 'scanProduct'])->name('product');
    Route::any('/scanned_product_details', [App\Http\Controllers\API\MobileappController::class, 'scannedProductDetails'])->name('product');

    Route::any('/remove_scanned_product', [App\Http\Controllers\API\MobileappController::class, 'removeScannedProduct'])->name('product');

    Route::post('/edit_user_details', [App\Http\Controllers\API\RegisterController::class, 'editUser'])->name('editUser');


    Route::post('/user_fcm_token', [App\Http\Controllers\API\RegisterController::class, 'fcmToken'])->name('fcmToken');


    Route::any('/chat_list', [App\Http\Controllers\API\ChatController::class, 'chatList'])->name('chatList');

    Route::any('/chat_details', [App\Http\Controllers\API\ChatController::class, 'chatDetails'])->name('chatDetails');

    Route::any('/new_chat', [App\Http\Controllers\API\ChatController::class, 'chatCreate'])->name('chatCreate');
    Route::post('/new_chat_message', [App\Http\Controllers\API\ChatController::class, 'chatMessage'])->name('chatCreate');

    Route::any('/new_product_warranty', [App\Http\Controllers\API\WarrantyController::class, 'newWarranty'])->name('newWarranty');
    Route::any('/warranty_list', [App\Http\Controllers\API\WarrantyController::class, 'warrantyList'])->name('warranty_list');
    Route::any('/warranty_details', [App\Http\Controllers\API\WarrantyController::class, 'warranty_details'])->name('warranty_details');

    Route::any('/warranty_update', [App\Http\Controllers\API\WarrantyController::class, 'warrantyUpdate'])->name('warrantyUpdate');

});



Route::any('/generateOtp', [
    'middleware' => 'checkSession',
    'uses'=>'RegisterController@sendOtp'
]);

Route::post('/verifyOtp', [
    'middleware' => 'checkSession',
    'uses'=>'RegisterController@verifyOtp'
]);
