<?php

use Illuminate\Support\Facades\Route;
use App\Http\Controllers\UserController;
use App\Http\Controllers\AppUserController;
use App\Http\Controllers\RoleController;
use App\Http\Controllers\PermissionController;
use App\Http\Controllers\CatergoriesController;
use App\Http\Controllers\CompanyController;
use App\Http\Controllers\ProductController;
use App\Http\Controllers\ReportController;
use App\Http\Controllers\Auth\ResetPasswordController;




/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Auth::routes();

Route::get('/', function () {
    \Artisan::call('schedule:run');
    return view('auth.login');
});
Route::get('/welcome', function () {
    return view('welcome');
});

Route::get('/home', [App\Http\Controllers\HomeController::class, 'index'])->name('home');

Route::get('/dashboard', [App\Http\Controllers\HomeController::class, 'index'])->name('dashboard');
Route::get('/dashboard/company', [App\Http\Controllers\HomeController::class, 'setCompany'])->name('company.dashboard');
Route::get('/dashboard/reset', [App\Http\Controllers\HomeController::class, 'resetCompany'])->name('reset.dashboard');

Route::get('/activate/{id}/{inv_token}', [App\Http\Controllers\UserController::class, 'activateUser'])->name('check.email');

Route::get('apppassword/reset', [App\Http\Controllers\UserController::class, 'appUserPasswordResetForm'])->name('appUserPasswordResetForm');
Route::post('apppassword/reset', [App\Http\Controllers\UserController::class, 'submitResetPassword'])->name('submitResetPassword');


// Route::get('/api/product', [App\Http\Controllers\APIController::class, 'product']);
// Route::get('/api/product/{batch_no?}', [App\Http\Controllers\APIController::class, 'product']);
// Route::get('/api/product/', [App\Http\Controllers\APIController::class, 'product']);

// Route::get('/users', [App\Http\Controllers\UserController::class, 'index'])->name('users.index');
// Route::get('/users/create', [App\Http\Controllers\UserController::class, 'create'])->name('users.create');
// Route::get('/users/store', [App\Http\Controllers\UserController::class, 'store'])->name('users.store');


// Route::get('/roles', [App\Http\Controllers\RoleController::class, 'index'])->name('roles.index');
// Route::get('/roles/create/', [App\Http\Controllers\RoleController::class, 'create'])->name('roles.create');
// Route::get('/roles/store/', [App\Http\Controllers\RoleController::class, 'store'])->name('roles.store');
// Route::get('/roles/show/', [App\Http\Controllers\RoleController::class, 'show'])->name('roles.show');
// Route::get('/roles/edit/', [App\Http\Controllers\RoleController::class, 'edit'])->name('roles.edit');
// Route::get('/roles/destroy/', [App\Http\Controllers\RoleController::class, 'destroy'])->name('roles.destroy');




// Auth::routes();

// Route::get('/home', [App\Http\Controllers\HomeController::class, 'index'])->name('home');
Route::get('/product-details/{product_code?}', [App\Http\Controllers\API\MobileappController::class, 'details']);

Route::get('testDatatable', [App\Http\Controllers\HomeController::class,'testDatatable']);
Route::get('object-list', [App\Http\Controllers\HomeController::class,'objectList']);


Route::group(['middleware' => ['auth','side_content']], function() {
    Route::resource('roles', RoleController::class);
    Route::resource('permissions', PermissionController::class);

    Route::resource('orders', App\Http\Controllers\OrderController::class);

    Route::get('order/details/{id}', [App\Http\Controllers\OrderController::class,'details'])->name('orders.details');



    Route::post('order/placeorder', [App\Http\Controllers\OrderController::class, 'placeOrder'])->name('placeorder');
    Route::post('order/verifyorder', [App\Http\Controllers\OrderController::class, 'verifyOrder'])->name('orders_verify');

    Route::get('order/approveorderdetails/{id}', [App\Http\Controllers\OrderController::class, 'approveOrderDetails'])->name('orders.approvedetails');


    Route::post('order/approveorder', [App\Http\Controllers\OrderController::class, 'approveOrder'])->name('orders_approve');


    Route::get('print_label_preview/{id}', [App\Http\Controllers\OrderController::class, 'labelPrintPreview'])->name('label.prient.preview');


    Route::get('order/order-batch/{id}', [App\Http\Controllers\OrderController::class, 'orderBatch'])->name('orders.batchs');
    Route::get('order/create-batch/{id}', [App\Http\Controllers\OrderController::class, 'createBatch'])->name('create.batche');
    Route::post('order/create-batch/{id}', [App\Http\Controllers\OrderController::class, 'saveBatch'])->name('orders.create.batches');
    Route::get('order/batch_details/{id}', [App\Http\Controllers\OrderController::class, 'batchDetails'])->name('orders.details.batches');
    
    Route::any('order-list', [App\Http\Controllers\OrderController::class, 'orderList']);


    Route::get('print_batch/{id}', [App\Http\Controllers\OrderController::class, 'printBatch'])->name('orders.printbatches');
    Route::get('print_batch_label_2/{id}', [App\Http\Controllers\OrderController::class, 'printLabel2'])->name('orders.printlabel2');
    Route::get('app-users',[App\Http\Controllers\UserController::class, 'appUsers'])->name('appUsers');

    Route::get('report/app-users',[App\Http\Controllers\UserController::class, 'appUsers'])->name('appUsers');


    Route::post('fetch-app-users',[App\Http\Controllers\UserController::class, 'fetchAppUsers'])->name('fetchAppUsers');
    Route::any('app-user-details/{id?}',[App\Http\Controllers\UserController::class, 'appUserDetails'])->name('app-users.show');

    
    Route::get('order/label_preview/{id}', [App\Http\Controllers\OrderController::class, 'productLabelPreview'])->name('orders.product_label_preview');
    Route::post('order/label_preview/{id}', [App\Http\Controllers\OrderController::class, 'labelPrintPreview'])->name('orders.label_print_preview');

    Route::get('order/label_preview_2/{id}', [App\Http\Controllers\OrderController::class, 'productLabelPreview2'])->name('orders.product_label_preview');

    Route::post('order/label_preview_2/{id}', [App\Http\Controllers\OrderController::class, 'labelPrintPreview2'])->name('orders.label_print_preview2');


    Route::resource('users', UserController::class);
    Route::get('validate_user_mail', [App\Http\Controllers\UserController::class, 'validateUserMail']);
    Route::get('validate_new_user_mail', [App\Http\Controllers\UserController::class, 'validateNewUserMail']);

    Route::get('validate_new_staff_code', [App\Http\Controllers\UserController::class, 'validateNewStaffCode']);
    Route::get('validate_staff_code', [App\Http\Controllers\UserController::class, 'validateStaffCode']);


    // Route::post('/users/company', [UserController::class,'userList'])->name('company_users');
    // Route::get('users/{company_id?}', [UserController::class,'index'])->name('users.company');
    // Route::get('fetch-users-lists', 'UserController@userList');
    // Route::get('/fetch-users-lists/{company_id?}', [App\Http\Controllers\UserController::class, 'userList']);
    Route::any('/fetch-users-lists', [App\Http\Controllers\UserController::class, 'userList']);

    Route::resource('appusers', AppUserController::class,['except' => ['show','edit','delete']]);

    Route::resource('products', ProductController::class);
    Route::any('/fetch-products-lists', [App\Http\Controllers\ProductController::class, 'productList']);
    Route::get('validate_new_product_code', [App\Http\Controllers\ProductController::class, 'validateNewProductCode']);
    Route::get('validate_product_code', [App\Http\Controllers\ProductController::class, 'validateProductCode']);
    
    Route::resource('categories', CatergoriesController::class);
    Route::any('/categories-fetch-list', [App\Http\Controllers\CatergoriesController::class, 'categoryList']);
    Route::post('/fetch-company-cat-list', [App\Http\Controllers\CatergoriesController::class, 'companyCategoryList']);
    Route::post('/fetch-company-main-cat-list', [App\Http\Controllers\CatergoriesController::class, 'companyMainCategoryList']);
    Route::post('/fetch-company-sub-cat-list', [App\Http\Controllers\CatergoriesController::class, 'companySubcategoryList']);
    Route::post('/add-category-modal', [App\Http\Controllers\CatergoriesController::class, 'addCategoryModal'])->name('add-category.modal');
    

    Route::any('/sub-category/create/{id}', [App\Http\Controllers\CatergoriesController::class, 'subCategoryCreate']);
    Route::post('/sub-category/create/{id}', [App\Http\Controllers\CatergoriesController::class, 'subCategoryStore'])->name('sub-categories.store');

    Route::get('/sub-category/edit/{id}', [App\Http\Controllers\CatergoriesController::class, 'subCategoryEdit']);
    
    Route::post('/sub-category/edit/{id}', [App\Http\Controllers\CatergoriesController::class, 'subCategoryUpdate'])->name('subCategoryUpdate');
    Route::get('validate_new_category', [App\Http\Controllers\CatergoriesController::class, 'validateNewCategory']);
    
    
    Route::resource('companies', CompanyController::class);
    Route::any('/fetch-company-list', [App\Http\Controllers\CompanyController::class, 'companyList']);
    Route::any('/fetch-company', [App\Http\Controllers\CompanyController::class, 'companyName']);
    Route::get('validate_company_mail', [App\Http\Controllers\CompanyController::class, 'validateCompanyMail']);
    Route::get('validate_new_company_mail', [App\Http\Controllers\CompanyController::class, 'validateNewCompanyMail']);
    Route::post('/fetch-company-logo', [App\Http\Controllers\CompanyController::class, 'fetchCompanyLogo']);
    Route::get('validate_new_company_code', [App\Http\Controllers\CompanyController::class, 'validateNewCompanyCode']);
    Route::get('validate_company_code', [App\Http\Controllers\CompanyController::class, 'validateCompanyCode']);
    Route::post('/fetch-state-list', [App\Http\Controllers\CompanyController::class, 'fetchStateList']);
    

    // Route::get('/activate/{id}/{inv_token}', [App\Http\Controllers\UserController::class, 'activateUser'])->name('check.email');
    Route::get('resend-email/{id}', [App\Http\Controllers\UserController::class, 'sendInvitation'])->name('resend.email');

    Route::get('edit-profile/', [App\Http\Controllers\UserController::class, 'editProfile'])->name('edit.profile');

    // Route::resource('/password/reset', App\Http\Controllers\Auth\ResetPasswordController::class)->name('reset.password');
    /*
    *
        Chats 
    *
    */
    Route::get('chats', [App\Http\Controllers\ChatController::class, 'index'])->name('chat.index');
    Route::any('chat-list', [App\Http\Controllers\ChatController::class, 'list'])->name('chat.list');
    Route::get('chat-details/{id}', [App\Http\Controllers\ChatController::class, 'show'])->name('chat.show');

    Route::post('chat-details/{id}', [App\Http\Controllers\ChatController::class, 'save'])->name('chat.store');

    Route::any('report/companies', [App\Http\Controllers\ReportController::class, 'companyReport']);
    Route::any('/fetch-company-report', [App\Http\Controllers\ReportController::class, 'companyReportList']);
    
    Route::any('report/products', [App\Http\Controllers\ReportController::class, 'productReport']);
    Route::any('/fetch-product-report', [App\Http\Controllers\ReportController::class, 'productReportList']);

    Route::any('report/batches', [App\Http\Controllers\ReportController::class, 'batchReport']);
    Route::any('/fetch-batch-report', [App\Http\Controllers\ReportController::class, 'batchReportList']);

    Route::any('report/scanned-products', [App\Http\Controllers\ReportController::class, 'scannedProductsReport']);
    Route::any('/fetch-scanned-products-report', [App\Http\Controllers\ReportController::class, 'scannedProductsReportList']);

    // Notification Controllers
    Route::post('send',[App\Http\Controllers\PushNotificationController::class, 'bulksend'])->name('bulksend');
    Route::get('all-notifications', [App\Http\Controllers\PushNotificationController::class, 'index'])->name('notification.index');;
    Route::get('get-notification-form', [App\Http\Controllers\PushNotificationController::class, 'create'])->name('notification.create');

    Route::any('notification-list', [App\Http\Controllers\PushNotificationController::class, 'notificationList']);
    
        
});


// Route::group(['middleware' => ['auth']], function() {
//     Route::get('/roles', [App\Http\Controllers\RoleController::class, 'index'])->name('roles.index');
//     Route::get('/roles/create/', [App\Http\Controllers\RoleController::class, 'create'])->name('roles.create');
//     Route::get('/roles/store/', [App\Http\Controllers\RoleController::class, 'store'])->name('roles.store');
//     Route::get('/roles/show/', [App\Http\Controllers\RoleController::class, 'show'])->name('roles.show');
//     Route::get('/roles/edit/', [App\Http\Controllers\RoleController::class, 'edit'])->name('roles.edit');
//     Route::get('/roles/destroy/', [App\Http\Controllers\RoleController::class, 'destroy'])->name('roles.destroy');
// });
